/*
 * Copyright (C) 2004-2005 Claudio "KLaN" Ciccani <klan@users.sf.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


#define PACCEL  mmx

static const uint64_t __used lmask[]  = { 0x000000ff000000ffull };

static const uint64_t __used wmask[]  = { 0x00ff00ff00ff00ffull };

static const uint64_t __used a1mask[] = { 0x8000800080008000ull };

static const uint64_t __used a8mask[] = { 0xffffffffffffffffull };

static const uint64_t __used b3mask[] = { 0xe0e0e0e0e0e0e0e0ull };

static const uint64_t __used b5mask[] = { 0xf8f8f8f8f8f8f8f8ull };

static const uint64_t __used b6mask[] = { 0xfcfcfcfcfcfcfcfcull };

/******************************** Begin YUY2 callbacks **********************************/

static
DFB_PFUNCTION( yuy2, yuy2 )
{
     uint8_t *S = frame->vo_frame.base[0];
     uint8_t *D = frame->out_plane[0];
     int      n = frame->area/4;

     __asm__ __volatile__(
          "movq      wmask, %%mm2\n\t"         // mm2: 00 ff 00 ff 00 ff 00 ff
          "psllw     $8, %%mm2\n\t"            // mm2: ff 00 ff 00 ff 00 ff 00
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movq      (%1), %%mm0\n\t"          // mm0: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm1\n\t"         // mm1: 00 y3 00 y2 00 y1 00 y0
          "testl     $3, %3\n\t"
          "jz        2f\n\t"
          "psubw     proc_table, %%mm1\n\t"    // y - proc_table.mmx.lm_sub
          "psllw     $3, %%mm1\n\t"            // y << 3 */
          "pmulhw    proc_table+24, %%mm1\n\t" // y * proc_table.mmx.lm_cfc
          "paddw     proc_table+8, %%mm1\n\t"  // y + proc_table.mmx.lm_add 
          "packuswb  %%mm1, %%mm1\n\t"         // mm1: y3 y2 y1 y0 y3 y2 y1 y0
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 y3 00 y2 00 y1 00 y0
          ".align 8\n"
          "2:\n\t"
          "pand      %%mm2, %%mm0\n\t"         // mm0: v2 00 u2 00 v0 00 u0 00
          "testl     $4, %3\n\t"
          "jz        3f\n\t"
          "psrlw     $8, %%mm0\n\t"            // mm0: 00 v2 00 u2 00 v0 00 u0
          "psubw     proc_table+16, %%mm0\n\t" // (u,v) - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // (u,v) << 3
          "pmulhw    proc_table+32, %%mm0\n\t" // (u,v) * proc_table.mmx.uv_cfc
          "paddw     proc_table+16, %%mm0\n\t" // (u,v) + proc_table.mmx.uv_sub
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: v2 u2 v0 u0 v2 u2 v0 u0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v2 00 u2 00 v0 00 u0
          "psllw     $8, %%mm0\n\t"            // mm0: v2 00 u2 00 v0 00 u0 00
          ".align 8\n"
          "3:\n\t"
          "por       %%mm1, %%mm0\n\t"         // mm0: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, (%0)\n\t"
          "addl      $8, %0\n\t"
          "addl      $8, %1\n\t"
          "decl      %2\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&S" (S), "=&c" (n)
          : "q" (frame->mixer_set), "0" (D), "1" (S), "2" (n)
          : "memory");
}

static
DFB_PFUNCTION( yuy2, uyvy )
{
     uint8_t *S = frame->vo_frame.base[0];
     uint8_t *D = frame->out_plane[0];
     int      n = frame->area/4;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          "testl     $7, %3\n\t"
          "jz        4f\n\t"
          /* apply correction */
          ".align 16\n"
          "1:\n\t"
          "movq      (%1), %%mm0\n\t"          // mm0: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm1\n\t"         // mm1: 00 y3 00 y2 00 y1 00 y0
          "psrlw     $8, %%mm0\n\t"            // mm0: 00 v2 00 u2 00 v0 00 u0
          "testl     $3, %3\n\t"
          "jz        2f\n\t"
          "psubw     proc_table, %%mm1\n\t"    // y - proc_table.mmx.lm_sub
          "psllw     $3, %%mm1\n\t"            // y << 3
          "pmulhw    proc_table+24, %%mm1\n\t" // y * proc_table.mmx.lm_cfc
          "paddw     proc_table+8, %%mm1\n\t"  // y + proc_table.mmx.lm_add
          "packuswb  %%mm1, %%mm1\n\t"         // mm1: y3 y2 y1 y0 y3 y2 y1 y0
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 y3 00 y2 00 y1 00 y0
          ".align 4\n"
          "2:\n\t"
          "testl     $4, %3\n\t"
          "jz        3f\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // (u,v) - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // (u,v) << 3
          "pmulhw    proc_table+32, %%mm0\n\t" // (u,v) * proc_table.mmx.uv_cfc
          "paddw     proc_table+16, %%mm0\n\t" // (u,v) + proc_table.mmx.uv_sub
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: v2 u2 v0 u0 v2 u2 v0 u0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v2 00 u2 00 v0 00 u0
          ".align 8\n"
          "3:\n\t"
          "psllw     $8, %%mm1\n\t"            // mm1: y3 00 y2 00 y1 00 y0 00
          "por       %%mm1, %%mm0\n\t"         // mm0: y3 v2 y2 u2 y1 v0 y0 u0
          "movq      %%mm0, (%0)\n\t"
          "addl      $8, %0\n\t"
          "addl      $8, %1\n\t"
          "decl      %2\n\t"
          "jnz       1b\n\t"
          "jmp       5f\n\t"
          /* don't apply correction */
          ".align 16\n"
          "4:\n\t"
          "movq      (%1), %%mm0\n\t"          // mm0: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm0\n\t"         // mm0: 00 y3 00 y2 00 y1 00 y0
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v2 00 u2 00 v0 00 u0
          "psllw     $8, %%mm0\n\t"            // mm0: y3 00 y2 00 y1 00 y0 00
          "por       %%mm1, %%mm0\n\t"         // mm0: y3 v2 y2 u2 y1 v0 y0 u0
          "movq      %%mm0, (%0)\n\t"
          "addl      $8, %0\n\t"
          "addl      $8, %1\n\t"
          "decl      %2\n\t"
          "jnz       4b\n\t"
          "5:\n\t"
          "emms"
          : "=&D" (D), "=&S" (S), "=&c" (n)
          : "q" (frame->mixer_set), "0" (D), "1" (S), "2" (n)
          : "memory");
}

static
DFB_PFUNCTION( yuy2, yv12 )
{
     uint8_t *S   = frame->vo_frame.base[0];
     uint8_t *Dy  = frame->out_plane[0];
     uint8_t *Du  = frame->out_plane[1];
     uint8_t *Dv  = frame->out_plane[2];
     int      n   = frame->height/2;
     int      set = frame->mixer_set;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          "testb     $7, %6\n\t"
          "jz        4f\n\t"
          /* apply correction */
          ".align 16\n"
          "1:\n\t"
          "movq      (%0), %%mm0\n\t"          // mm0: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      (%0,%4,4), %%mm1\n\t"     // mm1: v12 y13 u12 y12 v10 y11 u10 y10
          "movq      %%mm0, %%mm2\n\t"         // mm2: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      %%mm1, %%mm3\n\t"         // mm3: v12 y13 u12 y12 v10 y11 u10 y10
          "psrlw     $8, %%mm0\n\t"            // mm0: 00 v02 00 u02 00 v00 00 u00
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v12 00 u12 00 v10 00 u10
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y03 00 y02 00 y01 00 y00
          "pand      wmask, %%mm3\n\t"         // mm3: 00 y13 00 y12 00 y11 00 y10
          "paddw     %%mm1, %%mm0\n\t"         // (u,v)0X + (u,v)v1X
          "psrlw     $1, %%mm0\n\t"            // mm0: 00 v1 00 u1 00 v0 00 u0
          "testb     $3, %6\n\t"
          "jz        2f\n\t"
          "psubw     proc_table, %%mm2\n\t"    // y0X - proc_table.mmx.lm_sub
          "psubw     proc_table, %%mm3\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y0X << 3
          "psllw     $3, %%mm3\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y0X * proc_table.mmx.lm_cfc
          "pmulhw    proc_table+24, %%mm3\n\t" // y1X * proc_table.mmx.lm_cfc
          "paddw     proc_table+8, %%mm2\n\t"  // y0X + proc_table.mmx.lm_add
          "paddw     proc_table+8, %%mm3\n\t"  // y1X + proc_table.mmx.lm_add
          "2:\n\t"
          "testb     $4, %6\n\t"
          "jz        3f\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // (u,v) - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // (u,v) << 3
          "pmulhw    proc_table+32, %%mm0\n\t" // (u,v) * proc_table.mmx.uv_cfc
          "paddw     proc_table+16, %%mm0\n\t" // (u,v) + proc_table.mmx.uv_sub
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: v1 u1 v0 u0 v1 u1 v0 u0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v1 00 u1 00 v0 00 u0
          ".align 8\n"
          "3:\n\t"
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: y03 y02 y01 y00 y03 y02 y01 y00
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: y13 y12 y11 y10 y13 y12 y11 y10 
          "movq      %%mm0, %%mm1\n\t"         // mm1: 00 v1 00 u1 00 v0 00 u0
          "movd      %%mm2, (%1)\n\t" 
          "punpckhdq %%mm0, %%mm0\n\t"         // mm0: 00 v1 00 u1 00 v1 00 u1
          "movd      %%mm3, (%1,%4,2)\n\t"
          "punpcklbw %%mm0, %%mm1\n\t"         // mm1: 00 00 v1 v0 00 00 u1 u0
          "movd      %%mm1, (%2)\n\t"
          "punpckhdq %%mm1, %%mm1\n\t"         // mm1: 00 00 v1 v0 00 00 v1 v0
          "movd      %%mm1, (%3)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       1b\n\t"
          "movl      %4, %5\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %1\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %0\n\t"
          "shrl      $3, %5\n\t"
          "decl      %7\n\t"
          "jnz       1b\n\t"
          "jmp       5f\n\t"
          /* don't apply correction */
          ".align 16\n"
          "4:\n\t"
          "movq      (%0), %%mm0\n\t"          // mm0: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      (%0,%4,4), %%mm1\n\t"     // mm1: v12 y13 u12 y12 v10 y11 u10 y10
          "movq      %%mm0, %%mm2\n\t"         // mm2: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      %%mm1, %%mm3\n\t"         // mm3: v12 y13 u12 y12 v10 y11 u10 y10
          "psrlw     $8, %%mm0\n\t"            // mm0: 00 v02 00 u02 00 v00 00 u00
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v12 00 u12 00 v10 00 u10
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y03 00 y02 00 y01 00 y00
          "pand      wmask, %%mm3\n\t"         // mm3: 00 y13 00 y12 00 y11 00 y10
          "paddw     %%mm1, %%mm0\n\t"         // (u,v)0X + (u,v)v1X 
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: y03 y02 y01 y00 y03 y02 y01 y00
          "psrlw     $1, %%mm0\n\t"            // mm0: 00 v1 00 u1 00 v0 00 u0
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: y13 y12 y11 y10 y13 y12 y11 y10 
          "movq      %%mm0, %%mm1\n\t"         // mm1: 00 v1 00 u1 00 v0 00 u0
          "movd      %%mm2, (%1)\n\t" 
          "punpckhdq %%mm0, %%mm0\n\t"         // mm0: 00 v1 00 u1 00 v1 00 u1
          "movd      %%mm3, (%1,%4,2)\n\t"          
          "punpcklbw %%mm0, %%mm1\n\t"         // mm1: 00 00 v1 v0 00 00 u1 u0
          "movd      %%mm1, (%2)\n\t"
          "punpckhdq %%mm1, %%mm1\n\t"         // mm1: 00 00 v1 v0 00 00 v1 v0
          "movd      %%mm1, (%3)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       4b\n\t"
          "movl      %4, %5\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %1\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %0\n\t"
          "shrl      $3, %5\n\t"
          "decl      %7\n\t"
          "jnz       4b\n\t"
          "5:\n\t"
          "emms"
          : "=&S" (S), "=&r" (Dy), "=&r" (Du), "=&r" (Dv)
          : "q" (frame->width/2), "c" (frame->width/4), "m" (set), "m" (n),
            "0" (S), "1" (Dy), "2" (Du), "3" (Dv)
          : "memory" );
}

static
DFB_PFUNCTION( yuy2, nv12 )
{
     uint8_t *S   = frame->vo_frame.base[0];
     uint8_t *Dy  = frame->out_plane[0];
     uint8_t *Duv = frame->out_plane[1];
     int      n   = frame->height/2;
     int      set = frame->mixer_set;

     __asm__ __volatile__(
          "testl     $7, %5\n\t"
          "jz        4f\n\t"
          /* apply correction */
          ".align 16\n"
          "1:\n\t"
          "movq      (%0), %%mm0\n\t"          // mm0: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      (%0,%3,4), %%mm1\n\t"     // mm1: v12 y13 u12 y12 v10 y11 u10 y10
          "movq      %%mm0, %%mm2\n\t"         // mm2: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      %%mm1, %%mm3\n\t"         // mm3: v12 y13 u12 y12 v10 y11 u10 y10
          "psrlw     $8, %%mm0\n\t"            // mm0: 00 v02 00 u02 00 v00 00 u00
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v12 00 u12 00 v10 00 u10
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y03 00 y02 00 y01 00 y00
          "pand      wmask, %%mm3\n\t"         // mm3: 00 y13 00 y12 00 y11 00 y10
          "paddw     %%mm1, %%mm0\n\t"         // (u,v)0X + (u,v)v1X
          "psrlw     $1, %%mm0\n\t"            // mm0: 00 v1 00 u1 00 v0 00 u0
          "testl     $3, %5\n\t"
          "jz        2f\n\t"
          "psubw     proc_table, %%mm2\n\t"    // y0X - proc_table.mmx.lm_sub
          "psubw     proc_table, %%mm3\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y0X << 3
          "psllw     $3, %%mm3\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y0X * proc_table.mmx.lm_cfc
          "pmulhw    proc_table+24, %%mm3\n\t" // y1X * proc_table.mmx.lm_cfc
          "paddw     proc_table+8, %%mm2\n\t"  // y0X + proc_table.mmx.lm_add
          "paddw     proc_table+8, %%mm3\n\t"  // y1X + proc_table.mmx.lm_add
          "2:\n\t"
          "testl     $4, %5\n\t"
          "jz        3f\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // (u,v) - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // (u,v) << 3
          "pmulhw    proc_table+32, %%mm0\n\t" // (u,v) * proc_table.mmx.uv_cfc
          "paddw     proc_table+16, %%mm0\n\t" // (u,v) + proc_table.mmx.uv_sub
          ".align 8\n"
          "3:\n\t"
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: y03 y02 y01 y00 y03 y02 y01 y00
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: y13 y12 y11 y10 y13 y12 y11 y10
          "movd      %%mm2, (%1)\n\t"
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: v1 u1 v0 u0 v1 u1 v0 u0
          "movd      %%mm3, (%1,%3,2)\n\t"
          "movd      %%mm0, (%2)\n\t" 
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $4, %2\n\t"
          "decl      %4\n\t"
          "jnz       1b\n\t"
          "movl      %3, %4\n\t"
          "shll      $1, %4\n\t"
          "addl      %4, %1\n\t"
          "shll      $1, %4\n\t"
          "addl      %4, %0\n\t"
          "shrl      $3, %4\n\t"
          "decl      %6\n\t"
          "jnz       1b\n\t"
          "jmp       5f\n\t"
          /* don't apply correction */
          ".align 16\n"
          "4:\n\t"
          "movq      (%0), %%mm0\n\t"          // mm0: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      (%0,%3,4), %%mm1\n\t"     // mm1: v12 y13 u12 y12 v10 y11 u10 y10
          "movq      %%mm0, %%mm2\n\t"         // mm2: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      %%mm1, %%mm3\n\t"         // mm3: v12 y13 u12 y12 v10 y11 u10 y10
          "psrlw     $8, %%mm0\n\t"            // mm0: 00 v02 00 u02 00 v00 00 u00
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v12 00 u12 00 v10 00 u10
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y03 00 y02 00 y01 00 y00
          "pand      wmask, %%mm3\n\t"         // mm3: 00 y13 00 y12 00 y11 00 y10
          "paddw     %%mm1, %%mm0\n\t"         // (u,v)0X + (u,v)v1X 
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: y03 y02 y01 y00 y03 y02 y01 y00
          "psrlw     $1, %%mm0\n\t"            // mm0: 00 v1 00 u1 00 v0 00 u0
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: y13 y12 y11 y10 y13 y12 y11 y10
          "movd      %%mm2, (%1)\n\t"
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: v1 u1 v0 u0 v1 u1 v0 u0
          "movd      %%mm3, (%1,%3,2)\n\t"
          "movd      %%mm0, (%2)\n\t" 
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $4, %2\n\t"
          "decl      %4\n\t"
          "jnz       4b\n\t"
          "movl      %3, %4\n\t"
          "shll      $1, %4\n\t"
          "addl      %4, %1\n\t"
          "shll      $1, %4\n\t"
          "addl      %4, %0\n\t"
          "shrl      $3, %4\n\t"
          "decl      %6\n\t"
          "jnz       4b\n\t"
          "5:\n\t"
          "emms"
          : "=&S" (S), "=&r" (Dy), "=&r" (Duv)
          : "q" (frame->width/2), "c" (frame->width/4), "q" (set), "m" (n),
            "0" (S), "1" (Dy), "2" (Duv)
          : "memory" );
}

static
DFB_PFUNCTION( yuy2, nv21 )
{
     uint8_t *S   = frame->vo_frame.base[0];
     uint8_t *Dy  = frame->out_plane[0];
     uint8_t *Duv = frame->out_plane[1];
     int      n   = frame->height/2;
     int      set = frame->mixer_set;

     __asm__ __volatile__(
          "testl     $7, %5\n\t"
          "jz        4f\n\t"
          /* apply correction */
          ".align 16\n"
          "1:\n\t"
          "movq      (%0), %%mm0\n\t"          // mm0: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      (%0,%3,4), %%mm1\n\t"     // mm1: v12 y13 u12 y12 v10 y11 u10 y10
          "movq      %%mm0, %%mm2\n\t"         // mm2: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      %%mm1, %%mm3\n\t"         // mm3: v12 y13 u12 y12 v10 y11 u10 y10
          "psrlw     $8, %%mm0\n\t"            // mm0: 00 v02 00 u02 00 v00 00 u00
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v12 00 u12 00 v10 00 u10
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y03 00 y02 00 y01 00 y00
          "pand      wmask, %%mm3\n\t"         // mm3: 00 y13 00 y12 00 y11 00 y10
          "paddw     %%mm1, %%mm0\n\t"         // (u,v)0X + (u,v)v1X
          "psrlw     $1, %%mm0\n\t"            // mm0: 00 v1 00 u1 00 v0 00 u0
          "testl     $3, %5\n\t"
          "jz        2f\n\t"
          "psubw     proc_table, %%mm2\n\t"    // y0X - proc_table.mmx.lm_sub
          "psubw     proc_table, %%mm3\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y0X << 3
          "psllw     $3, %%mm3\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y0X * proc_table.mmx.lm_cfc
          "pmulhw    proc_table+24, %%mm3\n\t" // y1X * proc_table.mmx.lm_cfc
          "paddw     proc_table+8, %%mm2\n\t"  // y0X + proc_table.mmx.lm_add
          "paddw     proc_table+8, %%mm3\n\t"  // y1X + proc_table.mmx.lm_add
          "2:\n\t"
          "testl     $4, %5\n\t"
          "jz        3f\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // (u,v) - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // (u,v) << 3
          "pmulhw    proc_table+32, %%mm0\n\t" // (u,v) * proc_table.mmx.uv_cfc
          "paddw     proc_table+16, %%mm0\n\t" // (u,v) + proc_table.mmx.uv_sub
          ".align 8\n"
          "3:\n\t"
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: y03 y02 y01 y00 y03 y02 y01 y00
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: y13 y12 y11 y10 y13 y12 y11 y10 
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: v1 u1 v0 u0 v1 u1 v0 u0
          "movd      %%mm2, (%1)\n\t"
          "movq      %%mm0, %%mm1\n\t"         // mm1: v1 u1 v0 u0 v1 u1 v0 u0
          "movd      %%mm3, (%1,%3,2)\n\t"
          "psllw     $8, %%mm0\n\t"            // mm0: u1 00 u0 00 u1 00 u0 00
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v1 00 v0 00 v1 00 v0
          "por       %%mm1, %%mm0\n\t"         // mm0: u1 v1 u0 v0 u1 v1 u0 v0
          "movd      %%mm0, (%2)\n\t" 
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $4, %2\n\t"
          "decl      %4\n\t"
          "jnz       1b\n\t"
          "movl      %3, %4\n\t"
          "shll      $1, %4\n\t"
          "addl      %4, %1\n\t"
          "shll      $1, %4\n\t"
          "addl      %4, %0\n\t"
          "shrl      $3, %4\n\t"
          "decl      %6\n\t"
          "jnz       1b\n\t"
          "jmp       5f\n\t"
          /* don't apply correction */
          ".align 16\n"
          "4:\n\t"
          "movq      (%0), %%mm0\n\t"          // mm0: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      (%0,%3,4), %%mm1\n\t"     // mm1: v12 y13 u12 y12 v10 y11 u10 y10
          "movq      %%mm0, %%mm2\n\t"         // mm2: v02 y03 u02 y02 v00 y01 u00 y00
          "movq      %%mm1, %%mm3\n\t"         // mm3: v12 y13 u12 y12 v10 y11 u10 y10
          "psrlw     $8, %%mm0\n\t"            // mm0: 00 v02 00 u02 00 v00 00 u00
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v12 00 u12 00 v10 00 u10
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y03 00 y02 00 y01 00 y00
          "pand      wmask, %%mm3\n\t"         // mm3: 00 y13 00 y12 00 y11 00 y10
          "paddw     %%mm1, %%mm0\n\t"         // (u,v)0X + (u,v)v1X 
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: y03 y02 y01 y00 y03 y02 y01 y00
          "psrlw     $1, %%mm0\n\t"            // mm0: 00 v1 00 u1 00 v0 00 u0
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: y13 y12 y11 y10 y13 y12 y11 y10 
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: v1 u1 v0 u0 v1 u1 v0 u0
          "movd      %%mm2, (%1)\n\t"
          "movq      %%mm0, %%mm1\n\t"         // mm1: v1 u1 v0 u0 v1 u1 v0 u0
          "movd      %%mm3, (%1,%3,2)\n\t"
          "psllw     $8, %%mm0\n\t"            // mm0: u1 00 u0 00 u1 00 u0 00
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v1 00 v0 00 v1 00 v0
          "por       %%mm1, %%mm0\n\t"         // mm0: u1 v1 u0 v0 u1 v1 u0 v0
          "movd      %%mm0, (%2)\n\t" 
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $4, %2\n\t"
          "decl      %4\n\t"
          "jnz       4b\n\t"
          "movl      %3, %4\n\t"
          "shll      $1, %4\n\t"
          "addl      %4, %1\n\t"
          "shll      $1, %4\n\t"
          "addl      %4, %0\n\t"
          "shrl      $3, %4\n\t"
          "decl      %6\n\t"
          "jnz       4b\n\t"
          "5:\n\t"
          "emms"
          : "=&S" (S), "=&r" (Dy), "=&r" (Duv)
          : "q" (frame->width/2), "c" (frame->width/4), "q" (set), "m" (n),
            "0" (S), "1" (Dy), "2" (Duv)
          : "memory" );
}

static
DFB_PFUNCTION( yuy2, nv16 )
{ 
     uint8_t *S   = frame->vo_frame.base[0];
     uint8_t *Dy  = frame->out_plane[0];
     uint8_t *Dvu = frame->out_plane[1];
     int      n   = frame->area/4;

     __asm__ __volatile__(
          "testl     $7, %4\n\t"
          "jz        4f\n\t"
          /* apply correction */
          ".align 16\n"
          "movq      (%0), %%mm0\n\t"          // mm0: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm0\n\t"         // mm0: 00 y3 00 y2 00 y1 00 y0
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v2 00 u2 00 v0 00 u0
          "testl     $3, %4\n\t"
          "jz        2f\n\t"
          "psubw     proc_table, %%mm0\n\t"    // y - proc_table.mmx.lm_sub
          "psllw     $3, %%mm0\n\t"            // y << 3
          "pmulhw    proc_table+24, %%mm0\n\t" // y * proc_table.mmx.lm_cfc
          "paddw     proc_table+8, %%mm0\n\t"  // y + proc_table.mmx.lm_add
          ".align 4\n"
          "2:\n\t"
          "testl     $4, %4\n\t"
          "jz        3f\n\t"
          "psubw     proc_table+16, %%mm1\n\t" // (u,v) - proc_table.mmx.uv_sub
          "psllw     $3, %%mm1\n\t"            // (u,v) << 3
          "pmulhw    proc_table+32, %%mm1\n\t" // (u,v) * proc_table.mmx.uv_cfc
          "paddw     proc_table+16, %%mm1\n\t" // (u,v) + proc_table.mmx.uv_sub
          ".align 8\n"
          "3:\n\t"
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: y3 y2 y1 y0 y3 y2 y1 y0
          "packuswb  %%mm1, %%mm1\n\t"         // mm1: v2 u2 v0 u0 v2 u2 v0 u0 
          "movd      %%mm0, (%1)\n\t"
          "movd      %%mm1, (%2)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $4, %2\n\t"
          "decl      %3\n\t"
          "jnz       1b\n\t"
          "jmp       5f\n\t"
          /* don't apply correction */
          ".align 16\n"
          "4:\n\t"
          "movq      (%0), %%mm0\n\t"          // mm0: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm0\n\t"         // mm0: 00 y3 00 y2 00 y1 00 y0
          "psrlw     $8, %%mm1\n\t"            // mm1: 00 v2 00 u2 00 v0 00 u0
          "packuswb  %%mm0, %%mm0\n\t"         // mm0: y3 y2 y1 y0 y3 y2 y1 y0
          "packuswb  %%mm1, %%mm1\n\t"         // mm1: v2 u2 v0 u0 v2 u2 v0 u0
          "movd      %%mm0, (%1)\n\t"
          "movd      %%mm1, (%2)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $4, %2\n\t"
          "decl      %3\n\t"
          "jnz       4b\n\t"
          "5:\n\t"
          "emms"          
          : "=&S" (S), "=&r" (Dy), "=&r" (Dvu), "=&c" (n)
          : "q" (frame->mixer_set), "0" (S), "1" (Dy), "2" (Dvu), "3" (n)
          : "memory" );
}

static
DFB_PFUNCTION( yuy2, rgb332 )
{
     uint8_t *S = frame->vo_frame.base[0];
     uint8_t *D = frame->out_plane[0];
     int      n = frame->area/4;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t" 
          "movq      (%1), %%mm0\n\t"          // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm2\n\t"         // mm2: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y3 00 y2 00 y1 00 y0
          "psrld     $8, %%mm1\n\t"            // mm1: 00 v2 y3 u2 00 v0 y1 u0
          "psubw     proc_table, %%mm2\n\t"    // y - proc_table.mmx.lm_sub
          "pand      lmask, %%mm1\n\t"         // mm1: 00 00 00 u2 00 00 00 u0
          "psllw     $3, %%mm2\n\t"            // y << 3
          "packssdw  %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u0 00 u2 00 u0
          "pmulhw    proc_table+24, %%mm2\n\t" // y * proc_table.mmx.lm_cfc
          "punpcklwd %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u2 00 u0 00 u0
          "psrld     $24, %%mm0\n\t"           // mm0: 00 00 00 v2 00 00 00 v0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "packssdw  %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v0 00 v2 00 v0
          "psllw     $3, %%mm1\n\t"            // u << 3
          "punpcklwd %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v2 00 v0 00 v0
          "movq      %%mm1, %%mm4\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "pmulhw    proc_table+64, %%mm4\n\t" // u blue
          "psllw     $3, %%mm0\n\t"            // v << 3
          "paddw     %%mm2, %%mm4\n\t"         // mm4: XX b3 XX b2 XX b1 XX b0
          "movq      %%mm0, %%mm3\n\t"
          "packuswb  %%mm4, %%mm4\n\t"         // mm4: b3 b2 b1 b0 b3 b2 b1 b0
          "pmulhw    proc_table+40, %%mm3\n\t" // v red
          "punpcklbw %%mm7, %%mm4\n\t"         // mm4: 00 b3 00 b2 00 b1 00 b0
          "paddw     %%mm2, %%mm3\n\t"         // mm3: XX r3 XX r2 XX r1 XX r0
          "pmulhw    proc_table+48, %%mm0\n\t" // v green 
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: r3 r2 r1 r0 r3 r2 r1 r0
          "psrlw     $6, %%mm4\n\t"            // blue
          "pand      b3mask, %%mm3\n\t"
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 r3 00 r2 00 r1 00 r0
          "paddw     %%mm1, %%mm0\n\t"         // v green + u green  
          "por       %%mm4, %%mm3\n\t"         // blue | red
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g3 XX g2 XX g1 XX g0
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: g3 g2 g1 g0 g3 g2 g1 g0
          "pand      b3mask, %%mm2\n\t"         
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 g3 00 g2 00 g1 00 g0
          "psrlw     $3, %%mm2\n\t"            // green
          "por       %%mm2, %%mm3\n\t"
          "packuswb  %%mm3, %%mm3\n\t"         // pixels
          "movq      %%mm3, (%0)\n\t"
          "addl      $4, %0\n\t"
          "addl      $8, %1\n\t"
          "decl      %2\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&S" (S), "=&c" (n)
          : "0" (D), "1" (S), "2" (n)
          : "memory");
}

static
DFB_PFUNCTION( yuy2, argb1555 )
{
     uint8_t *S = frame->vo_frame.base[0];
     uint8_t *D = frame->out_plane[0];
     int      n = frame->area/4;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t" 
          "movq      (%1), %%mm0\n\t"          // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm2\n\t"         // mm2: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y3 00 y2 00 y1 00 y0
          "psrld     $8, %%mm1\n\t"            // mm1: 00 v2 y3 u2 00 v0 y1 u0
          "psubw     proc_table, %%mm2\n\t"    // y - proc_table.mmx.lm_sub
          "pand      lmask, %%mm1\n\t"         // mm1: 00 00 00 u2 00 00 00 u0
          "psllw     $3, %%mm2\n\t"            // y << 3
          "packssdw  %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u0 00 u2 00 u0
          "pmulhw    proc_table+24, %%mm2\n\t" // y * proc_table.mmx.lm_cfc
          "punpcklwd %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u2 00 u0 00 u0
          "psrld     $24, %%mm0\n\t"           // mm0: 00 00 00 v2 00 00 00 v0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "packssdw  %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v0 00 v2 00 v0
          "psllw     $3, %%mm1\n\t"            // u << 3
          "punpcklwd %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v2 00 v0 00 v0
          "movq      %%mm1, %%mm4\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "pmulhw    proc_table+64, %%mm4\n\t" // u blue
          "psllw     $3, %%mm0\n\t"            // v << 3
          "paddw     %%mm2, %%mm4\n\t"         // mm4: XX b3 XX b2 XX b1 XX b0
          "movq      %%mm0, %%mm3\n\t"
          "packuswb  %%mm4, %%mm4\n\t"         // mm4: b3 b2 b1 b0 b3 b2 b1 b0
          "pmulhw    proc_table+40, %%mm3\n\t" // v red
          "punpcklbw %%mm7, %%mm4\n\t"         // mm4: 00 b3 00 b2 00 b1 00 b0
          "paddw     %%mm2, %%mm3\n\t"         // mm3: XX r3 XX r2 XX r1 XX r0
          "pmulhw    proc_table+48, %%mm0\n\t" // v green 
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: r3 r2 r1 r0 r3 r2 r1 r0
          "psrlw     $3, %%mm4\n\t"            // blue
          "pand      b5mask, %%mm3\n\t"
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 r3 00 r2 00 r1 00 r0
          "paddw     %%mm1, %%mm0\n\t"         // v green + u green 
          "psllw     $7, %%mm3\n\t"            // mm3: r3 00 r2 00 r1 00 r0 00
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g3 XX g2 XX g1 XX g0
          "por       %%mm4, %%mm3\n\t"         // blue | red
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: g3 g2 g1 g0 g3 g2 g1 g0
          "pand      b5mask, %%mm2\n\t"
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 g3 00 g2 00 g1 00 g0
          "por       a1mask, %%mm3\n\t"        // blue | red | alpha
          "psllw     $2, %%mm2\n\t"            // green
          "por       %%mm2, %%mm3\n\t"         // pixels
          "movq      %%mm3, (%0)\n\t"
          "addl      $8, %0\n\t"
          "addl      $8, %1\n\t"
          "decl      %2\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&S" (S), "=&c" (n)
          : "0" (D), "1" (S), "2" (n)
          : "memory");
}

static
DFB_PFUNCTION( yuy2, rgb16 )
{
     uint8_t *S = frame->vo_frame.base[0];
     uint8_t *D = frame->out_plane[0];
     int      n = frame->area/4;
 
     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movq      (%1), %%mm0\n\t"          // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm2\n\t"         // mm2: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y3 00 y2 00 y1 00 y0
          "psrld     $8, %%mm1\n\t"            // mm1: 00 v2 y3 u2 00 v0 y1 u0
          "psubw     proc_table, %%mm2\n\t"    // y - proc_table.mmx.lm_sub
          "pand      lmask, %%mm1\n\t"         // mm1: 00 00 00 u2 00 00 00 u0
          "psllw     $3, %%mm2\n\t"            // y << 3
          "packssdw  %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u0 00 u2 00 u0
          "pmulhw    proc_table+24, %%mm2\n\t" // y * proc_table.mmx.lm_cfc
          "punpcklwd %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u2 00 u0 00 u0
          "psrld     $24, %%mm0\n\t"           // mm0: 00 00 00 v2 00 00 00 v0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "packssdw  %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v0 00 v2 00 v0
          "psllw     $3, %%mm1\n\t"            // u << 3
          "punpcklwd %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v2 00 v0 00 v0
          "movq      %%mm1, %%mm4\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "pmulhw    proc_table+64, %%mm4\n\t" // u blue
          "psllw     $3, %%mm0\n\t"            // v << 3
          "paddw     %%mm2, %%mm4\n\t"         // mm4: XX b3 XX b2 XX b1 XX b0
          "movq      %%mm0, %%mm3\n\t"
          "packuswb  %%mm4, %%mm4\n\t"         // mm4: b3 b2 b1 b0 b3 b2 b1 b0
          "pmulhw    proc_table+40, %%mm3\n\t" // v red
          "punpcklbw %%mm7, %%mm4\n\t"         // mm4: 00 b3 00 b2 00 b1 00 b0
          "paddw     %%mm2, %%mm3\n\t"         // mm3: XX r3 XX r2 XX r1 XX r0
          "pmulhw    proc_table+48, %%mm0\n\t" // v green 
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: r3 r2 r1 r0 r3 r2 r1 r0
          "psrlw     $3, %%mm4\n\t"            // blue
          "pand      b5mask, %%mm3\n\t"
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 r3 00 r2 00 r1 00 r0
          "paddw     %%mm1, %%mm0\n\t"         // v green + u green 
          "psllw     $8, %%mm3\n\t"            // mm3: r3 00 r2 00 r1 00 r0 00
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g3 XX g2 XX g1 XX g0
          "por       %%mm4, %%mm3\n\t"         // blue | red
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: g3 g2 g1 g0 g3 g2 g1 g0
          "pand      b6mask, %%mm2\n\t"
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 g3 00 g2 00 g1 00 g0
          "psllw     $3, %%mm2\n\t"            // green
          "por       %%mm2, %%mm3\n\t"         // pixels
          "movq      %%mm3, (%0)\n\t"
          "addl      $8, %0\n\t"
          "addl      $8, %1\n\t"
          "decl      %2\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&S" (S), "=&c" (n)
          : "0" (D), "1" (S), "2" (n)
          : "memory");
}

static
DFB_PFUNCTION( yuy2, rgb24 )
{
     uint8_t *S = frame->vo_frame.base[0];
     uint8_t *D = frame->out_plane[0];
     int      n = frame->area/4;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movq      (%1), %%mm0\n\t"          // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm2\n\t"         // mm2: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y3 00 y2 00 y1 00 y0
          "psrld     $8, %%mm1\n\t"            // mm1: 00 v2 y3 u2 00 v0 y1 u0
          "psubw     proc_table, %%mm2\n\t"    // y - proc_table.mmx.lm_sub
          "pand      lmask, %%mm1\n\t"         // mm1: 00 00 00 u2 00 00 00 u0
          "psllw     $3, %%mm2\n\t"            // y << 3
          "packssdw  %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u0 00 u2 00 u0
          "pmulhw    proc_table+24, %%mm2\n\t" // y * proc_table.mmx.lm_cfc
          "punpcklwd %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u2 00 u0 00 u0
          "psrld     $24, %%mm0\n\t"           // mm0: 00 00 00 v2 00 00 00 v0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "packssdw  %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v0 00 v2 00 v0
          "psllw     $3, %%mm1\n\t"            // u << 3
          "punpcklwd %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v2 00 v0 00 v0
          "movq      %%mm1, %%mm4\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "pmulhw    proc_table+64, %%mm4\n\t" // u blue
          "psllw     $3, %%mm0\n\t"            // v << 3
          "paddw     %%mm2, %%mm4\n\t"         // mm4: XX b3 XX b2 XX b1 XX b0
          "movq      %%mm0, %%mm3\n\t"
          "packuswb  %%mm4, %%mm4\n\t"         // mm4: b3 b2 b1 b0 b3 b2 b1 b0
          "pmulhw    proc_table+40, %%mm3\n\t" // v red
          "movq      %%mm4, %%mm5\n\t"         // mm5: b3 b2 b1 b0 b3 b2 b1 b0
          "paddw     %%mm2, %%mm3\n\t"         // mm3: XX r3 XX r2 XX r1 XX r0
          "pmulhw    proc_table+48, %%mm0\n\t" // v green 
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: r3 r2 r1 r0 r3 r2 r1 r0
          "punpcklbw %%mm3, %%mm4\n\t"         // mm4: r3 b3 r2 b2 r1 b1 r0 b0
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "psrld     $8, %%mm4\n\t"            // mm4: 00 r3 b3 r2 00 r1 b1 r0
          "paddw     %%mm1, %%mm0\n\t"         // v green + u green
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g3 XX g2 XX g1 XX g0 
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: g3 g2 g1 g0 g3 g2 g1 g0
          "punpcklbw %%mm2, %%mm5\n\t"         // mm5: g3 b3 g2 b2 g1 b1 g0 b0
          "movq      %%mm5, %%mm6\n\t"         // mm6: g3 b3 g2 b2 g1 b1 g0 b0
          "punpcklwd %%mm4, %%mm5\n\t"         // mm5: 00 r1 g1 b1 b1 r0 g0 b0
          "movq      %%mm5, %%mm0\n\t"         // mm0: 00 r1 g1 b1 b1 r0 g0 b0
          "punpckhwd %%mm4, %%mm6\n\t"         // mm6: 00 r3 g3 b3 b3 r2 g2 b2
          "psrlq     $40, %%mm0\n\t"           // mm0: 00 00 00 00 00 00 r1 g1
          "punpcklwd %%mm6, %%mm0\n\t"         // mm0: b3 r2 00 00 g2 b2 r1 g1
          "punpckldq %%mm0, %%mm5\n\t"         // mm5: g2 b2 r1 g1 b1 r0 g0 b0
          "psrld     $8, %%mm6\n\t"            // mm6: 00 00 r3 g3 0 b3 r2 g2
          "psrld     $16, %%mm0\n\t"           // mm0: 00 00 b3 r2 00 00 g2 b2
          "punpckhwd %%mm6, %%mm0\n\t"         // mm0: 00 00 00 00 r3 g3 b3 r2
          "movq      %%mm5,  (%0)\n\t"
          "movd      %%mm0, 8(%0)\n\t"
          "addl      $12, %0\n\t"
          "addl      $8,  %1\n\t"
          "decl      %2\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&S" (S), "=&c" (n)
          : "0" (D), "1" (S), "2" (n)
          : "memory");
}

static
DFB_PFUNCTION( yuy2, rgb32 )
{
     uint8_t *S = frame->vo_frame.base[0];
     uint8_t *D = frame->out_plane[0];
     int      n = frame->area/4;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movq      (%1), %%mm0\n\t"          // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm2\n\t"         // mm2: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y3 00 y2 00 y1 00 y0
          "psrld     $8, %%mm1\n\t"            // mm1: 00 v2 y3 u2 00 v0 y1 u0
          "psubw     proc_table, %%mm2\n\t"    // y - proc_table.mmx.lm_sub
          "pand      lmask, %%mm1\n\t"         // mm1: 00 00 00 u2 00 00 00 u0
          "psllw     $3, %%mm2\n\t"            // y << 3
          "packssdw  %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u0 00 u2 00 u0
          "pmulhw    proc_table+24, %%mm2\n\t" // y * proc_table.mmx.lm_cfc
          "punpcklwd %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u2 00 u0 00 u0
          "psrld     $24, %%mm0\n\t"           // mm0: 00 00 00 v2 00 00 00 v0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "packssdw  %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v0 00 v2 00 v0
          "psllw     $3, %%mm1\n\t"            // u << 3
          "punpcklwd %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v2 00 v0 00 v0
          "movq      %%mm1, %%mm4\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "pmulhw    proc_table+64, %%mm4\n\t" // u blue
          "psllw     $3, %%mm0\n\t"            // v << 3
          "paddw     %%mm2, %%mm4\n\t"         // mm4: XX b3 XX b2 XX b1 XX b0
          "movq      %%mm0, %%mm3\n\t"
          "packuswb  %%mm4, %%mm4\n\t"         // mm4: b3 b2 b1 b0 b3 b2 b1 b0
          "pmulhw    proc_table+40, %%mm3\n\t" // v red
          "paddw     %%mm2, %%mm3\n\t"         // mm3: XX r3 XX r2 XX r1 XX r0
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: r3 r2 r1 r0 r3 r2 r1 r0
          "pmulhw    proc_table+48, %%mm0\n\t" // v green 
          "punpcklbw %%mm3, %%mm4\n\t"         // mm4: r3 b3 r2 b2 r1 b1 r0 b0
          "movq      %%mm4, %%mm5\n\t"         // mm5: r3 b3 r2 b2 r1 b1 r0 b0
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "paddw     %%mm1, %%mm0\n\t"         // v green + u green
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g3 XX g2 XX g1 XX g0 
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: g3 g2 g1 g0 g3 g2 g1 g0
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 g3 00 g2 00 g1 00 g0
          "punpcklbw %%mm2, %%mm4\n\t"         // mm4: 00 r1 g1 b1 00 r0 g0 b0
          "punpckhbw %%mm2, %%mm5\n\t"         // mm5: 00 r3 g3 b3 00 r2 g2 b2
          "movq      %%mm4,  (%0)\n\t"
          "movq      %%mm5, 8(%0)\n\t"
          "addl      $16, %0\n\t"
          "addl      $8,  %1\n\t"
          "decl      %2\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&S" (S), "=&c" (n)
          : "0" (D), "1" (S), "2" (n)
          : "memory");
}

static
DFB_PFUNCTION( yuy2, argb )
{
     uint8_t *S = frame->vo_frame.base[0];
     uint8_t *D = frame->out_plane[0];
     int      n = frame->area/4;

     __asm__ __volatile__(
          "movq      a8mask, %%mm6\n\t"        // mm6: ff ff ff ff ff ff ff ff
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movq      (%1), %%mm0\n\t"          // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm2\n\t"         // mm2: v2 y3 u2 y2 v0 y1 u0 y0
          "movq      %%mm0, %%mm1\n\t"         // mm1: v2 y3 u2 y2 v0 y1 u0 y0
          "pand      wmask, %%mm2\n\t"         // mm2: 00 y3 00 y2 00 y1 00 y0
          "psrld     $8, %%mm1\n\t"            // mm1: 00 v2 y3 u2 00 v0 y1 u0
          "psubw     proc_table, %%mm2\n\t"    // y - proc_table.mmx.lm_sub
          "pand      lmask, %%mm1\n\t"         // mm1: 00 00 00 u2 00 00 00 u0
          "psllw     $3, %%mm2\n\t"            // y << 3
          "packssdw  %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u0 00 u2 00 u0
          "pmulhw    proc_table+24, %%mm2\n\t" // y * proc_table.mmx.lm_cfc
          "punpcklwd %%mm1, %%mm1\n\t"         // mm1: 00 u2 00 u2 00 u0 00 u0
          "psrld     $24, %%mm0\n\t"           // mm0: 00 00 00 v2 00 00 00 v0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "packssdw  %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v0 00 v2 00 v0
          "psllw     $3, %%mm1\n\t"            // u << 3
          "punpcklwd %%mm0, %%mm0\n\t"         // mm0: 00 v2 00 v2 00 v0 00 v0
          "movq      %%mm1, %%mm4\n\t"
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "pmulhw    proc_table+64, %%mm4\n\t" // u blue
          "psllw     $3, %%mm0\n\t"            // v << 3
          "paddw     %%mm2, %%mm4\n\t"         // mm4: XX b3 XX b2 XX b1 XX b0
          "movq      %%mm0, %%mm3\n\t"
          "packuswb  %%mm4, %%mm4\n\t"         // mm4: b3 b2 b1 b0 b3 b2 b1 b0
          "pmulhw    proc_table+40, %%mm3\n\t" // v red
          "paddw     %%mm2, %%mm3\n\t"         // mm3: XX r3 XX r2 XX r1 XX r0
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: r3 r2 r1 r0 r3 r2 r1 r0
          "pmulhw    proc_table+48, %%mm0\n\t" // v green 
          "punpcklbw %%mm3, %%mm4\n\t"         // mm4: r3 b3 r2 b2 r1 b1 r0 b0
          "movq      %%mm4, %%mm5\n\t"         // mm5: r3 b3 r2 b2 r1 b1 r0 b0
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "paddw     %%mm1, %%mm0\n\t"         // v green + u green
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g3 XX g2 XX g1 XX g0 
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: g3 g2 g1 g0 g3 g2 g1 g0
          "punpcklbw %%mm6, %%mm2\n\t"         // mm2: ff g3 ff g2 ff g1 ff g0
          "punpcklbw %%mm2, %%mm4\n\t"         // mm4: ff r1 g1 b1 ff r0 g0 b0
          "punpckhbw %%mm2, %%mm5\n\t"         // mm5: ff r3 g3 b3 ff r2 g2 b2
          "movq      %%mm4,  (%0)\n\t"
          "movq      %%mm5, 8(%0)\n\t"
          "addl      $16, %0\n\t"
          "addl      $8,  %1\n\t"
          "decl      %2\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&S" (S), "=&c" (n)
          : "0" (D), "1" (S), "2" (n)
          : "memory");
}

/******************************** End of YV12 callbacks *********************************/

/******************************** Begin YV12 callbacks **********************************/

static
DFB_PFUNCTION( yv12, yuy2 )
{
     uint8_t *Sy  = frame->vo_frame.base[0];
     uint8_t *Su  = frame->vo_frame.base[1];
     uint8_t *Sv  = frame->vo_frame.base[2];
     uint8_t *D   = frame->out_plane[0];
     int      n   = frame->height/2;
     int      set = frame->mixer_set;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          "testb     $7, %6\n\t"
          "jz        4f\n\t"
          /* apply correction */
          ".align 16\n"
          "1:\n\t"
          "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 y03 y02 y01 y00
          "movd      (%1,%4), %%mm1\n\t"       // mm1: 00 00 00 00 y13 y12 y11 y10 
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 y03 00 y02 00 y01 00 y00
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 y13 00 y12 00 y11 00 y10
          "movd      (%2), %%mm2\n\t"          // mm2: 00 00 00 00 u3 u2 u1 u0
          "movd      (%3), %%mm3\n\t"          // mm3: 00 00 00 00 v3 v2 v1 v0
          "testb     $3, %6\n\t"
          "jz        2f\n\t"
          "psubw     proc_table, %%mm0\n\t"    // y0X - proc_table.mmx.lm_sub
          "psubw     proc_table, %%mm1\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm0\n\t"            // y1X << 3
          "psllw     $3, %%mm1\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm0\n\t" // y0X * proc_table.mmx.lm_cfc
          "pmulhw    proc_table+24, %%mm1\n\t" // y1X * proc_table.mmx.lm_cfc
          "paddw     proc_table+8, %%mm0\n\t"  // y0X + proc_table.mmx.lm_add
          "paddw     proc_table+8, %%mm1\n\t"  // y1X + proc_table.mmx.lm_add
          ".align 4\n"
          "2:\n\t"
          "testb     $4, %6\n\t"
          "jz        3f\n\t"
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 u3 00 u2 00 u1 00 u0
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 v3 00 v2 00 v1 00 v0
          "psubw     proc_table+16, %%mm2\n\t" // u - proc_table.mmx.uv_sub
          "psubw     proc_table+16, %%mm3\n\t" // v - proc_table.mmx.uv_sub
          "psllw     $3, %%mm2\n\t"            // u << 3
          "psllw     $3, %%mm3\n\t"            // v << 3
          "pmulhw    proc_table+32, %%mm2\n\t" // u * proc_table.mmx.uv_cfc
          "pmulhw    proc_table+32, %%mm3\n\t" // v * proc_table.mmx.uv_cfc
          "paddw     proc_table+16, %%mm2\n\t" // u + proc_table.mmx.uv_sub
          "paddw     proc_table+16, %%mm3\n\t" // v + proc_table.mmx.uv_sub
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: u3 u2 u1 u0 u3 u2 u1 u0
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: v3 v2 v1 v0 v3 v2 v1 v0
          ".align 8\n"
          "3:\n\t"
          "packuswb  %%mm1, %%mm0\n\t"         // mm0: y13 y12 y11 y10 y03 y02 y01 y00
          "punpcklbw %%mm3, %%mm2\n\t"         // mm2: v3 u3 v2 u2 v1 u1 v0 u0
          "movq      %%mm0, %%mm1\n\t"         // mm1: y13 y12 y11 y10 y03 y02 y01 y00
          "punpckhdq %%mm0, %%mm0\n\t"         // mm0: y13 y12 y11 y10 y13 y12 y11 y10
          "punpcklbw %%mm2, %%mm1\n\t"         // mm1: v1 y03 u1 y02 v0 y01 u0 y00
          "punpcklbw %%mm2, %%mm0\n\t"         // mm0: v1 y13 u1 y12 v0 y11 u0 y10
          "movq      %%mm1, (%0)\n\t"
          "movq      %%mm0, (%0,%4,2)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       1b\n\t"
          "movl      %4, %5\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %0\n\t"
          "addl      %4, %1\n\t"
          "shrl      $3, %5\n\t"
          "decl      %7\n\t"
          "jnz       1b\n\t"
          "jmp       5f\n\t"
          /* don't apply correction */
          ".align 16\n"
          "4:\n"
          "movd      (%2), %%mm2\n\t"          // mm2: 00 00 00 00 u3 u2 u1 u0
          "movd      (%3), %%mm3\n\t"          // mm3: 00 00 00 00 v3 v2 v1 v0
          "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 y03 y02 y01 y00
          "movd      (%1,%4), %%mm1\n\t"       // mm1: 00 00 00 00 y13 y12 y11 y10
          "punpcklbw %%mm3, %%mm2\n\t"         // mm2: v3 u3 v2 u2 v1 u1 v0 u0
          "punpcklbw %%mm2, %%mm0\n\t"         // mm0: v1 y03 u1 y02 v0 y01 u0 y00
          "punpcklbw %%mm2, %%mm1\n\t"         // mm1: v1 y13 u1 y12 v0 y11 u0 y10
          "movq      %%mm0, (%0)\n\t"
          "movq      %%mm1, (%0,%4,2)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       4b\n\t"
          "movl      %4, %5\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %0\n\t"
          "addl      %4, %1\n\t"
          "shrl      $3, %5\n\t"
          "decl      %7\n\t"
          "jnz       4b\n\t"
          "5:\n\t"
          "emms"
          : "=&D" (D), "=&r" (Sy), "=&r" (Su), "=&r" (Sv)
          : "q" (frame->width), "c" (frame->width/4), "m" (set), "m" (n),
            "0" (D), "1" (Sy), "2" (Su), "3" (Sv)
          : "memory");
}

static
DFB_PFUNCTION( yv12, uyvy )
{
     uint8_t *Sy  = frame->vo_frame.base[0];
     uint8_t *Su  = frame->vo_frame.base[1];
     uint8_t *Sv  = frame->vo_frame.base[2];
     uint8_t *D   = frame->out_plane[0];
     int      n   = frame->height/2;
     int      set = frame->mixer_set;
     
     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          "testb     $7, %6\n\t"
          "jz        4f\n\t"
          /* apply correction */
          ".align 16\n"
          "1:\n\t"
          "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 y03 y02 y01 y00
          "movd      (%1,%4), %%mm1\n\t"       // mm1: 00 00 00 00 y13 y12 y10 y10 
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 y03 00 y02 00 y01 00 y00
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 y13 00 y12 00 y11 00 y10
          "movd      (%2), %%mm2\n\t"          // mm2: 00 00 00 00 u3 u2 u1 u0
          "movd      (%3), %%mm3\n\t"          // mm3: 00 00 00 00 v3 v2 v1 v0
          "testb     $3, %6\n\t"
          "jz        2f\n\t"
          "psubw     proc_table, %%mm0\n\t"    // y0X - proc_table.mmx.lm_sub
          "psubw     proc_table, %%mm1\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm0\n\t"            // y0X << 3
          "psllw     $3, %%mm1\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm0\n\t" // y0X * proc_table.mmx.lm_cfc
          "pmulhw    proc_table+24, %%mm1\n\t" // y1X * proc_table.mmx.lm_cfc
          "paddw     proc_table+8, %%mm0\n\t"  // y0X + proc_table.mmx.lm_add
          "paddw     proc_table+8, %%mm1\n\t"  // y1X + proc_table.mmx.lm_add
          ".align 4\n"
          "2:\n\t"          
          "testb     $4, %6\n\t"
          "jz        3f\n\t"
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 u3 00 u2 00 u1 00 u0
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 v3 00 v2 00 v1 00 v0
          "psubw     proc_table+16, %%mm2\n\t" // u - proc_table.mmx.uv_sub
          "psubw     proc_table+16, %%mm3\n\t" // v - proc_table.mmx.uv_sub
          "psllw     $3, %%mm2\n\t"            // u << 3
          "psllw     $3, %%mm3\n\t"            // v << 3
          "pmulhw    proc_table+32, %%mm2\n\t" // u * proc_table.mmx.uv_cfc
          "pmulhw    proc_table+32, %%mm3\n\t" // v * proc_table.mmx.uv_cfc
          "paddw     proc_table+16, %%mm2\n\t" // u + proc_table.mmx.uv_sub
          "paddw     proc_table+16, %%mm3\n\t" // v + proc_table.mmx.uv_sub
          "packuswb  %%mm2, %%mm2\n\t"         // mm2: u3 u2 u1 u0 u3 u2 u1 u0
          "packuswb  %%mm3, %%mm3\n\t"         // mm3: v3 v2 v1 v0 v3 v2 v1 v0
          ".align 8\n"
          "3:\n\t"
          "packuswb  %%mm1, %%mm0\n\t"         // mm0: y13 y12 y10 y10 y03 y02 y01 y00
          "punpcklbw %%mm3, %%mm2\n\t"         // mm2: v3 u3 v2 u2 v1 u1 v0 u0 
          "movq      %%mm2, %%mm3\n\t"         // mm3: v3 u3 v2 u2 v1 u1 v0 u0
          "punpcklbw %%mm0, %%mm3\n\t"         // mm3: y03 v1 y02 u1 y01 v0 y00 u0
          "punpckhdq %%mm0, %%mm0\n\t"         // mm0: y13 y12 y10 y10 y13 y12 y10 y10
          "punpcklbw %%mm0, %%mm2\n\t"         // mm2: y13 v1 y12 u1 y11 v0 y10 u0
          "movq      %%mm3, (%0)\n\t" 
          "movq      %%mm2, (%0,%4,2)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       1b\n\t"
          "movl      %4, %5\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %0\n\t"
          "addl      %4, %1\n\t"
          "shrl      $3, %5\n\t"
          "decl      %7\n\t"
          "jnz       1b\n\t"
          "jmp       5f\n\t"
          /* don't apply correction */
          ".align 16\n"
          "4:\n\t"
          "movd      (%2), %%mm2\n\t"          // mm2: 00 00 00 00 u3 u2 u1 u0
          "movd      (%3), %%mm3\n\t"          // mm3: 00 00 00 00 v3 v2 v1 v0
          "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 y03 y02 y01 y00
          "movd      (%1,%4), %%mm1\n\t"       // mm1: 00 00 00 00 y13 y12 y10 y10
          "punpcklbw %%mm3, %%mm2\n\t"         // mm2: v3 u3 v2 u2 v1 u1 v0 u0
          "movq      %%mm2, %%mm3\n\t"         // mm3: v3 u3 v2 u2 v1 u1 v0 u0
          "punpcklbw %%mm0, %%mm2\n\t"         // mm2: y03 v1 y02 u1 y01 v0 y00 u0
          "punpcklbw %%mm1, %%mm3\n\t"         // mm3: y13 v1 y12 u1 y11 v0 y10 u0
          "movq      %%mm2, (%0)\n\t" 
          "movq      %%mm3, (%0,%4,2)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       4b\n\t"
          "movl      %4, %5\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %0\n\t"
          "addl      %4, %1\n\t"
          "shrl      $3, %5\n\t"
          "decl      %7\n\t"
          "jnz       4b\n\t"
          "5:\n\t"
          "emms"
          : "=&D" (D), "=&r" (Sy), "=&r" (Su), "=&r" (Sv)
          : "q" (frame->width), "c" (frame->width/4), "m" (set), "m" (n),
            "0" (D), "1" (Sy), "2" (Su), "3" (Sv)
          : "memory");
}

static
DFB_PFUNCTION( yv12, yv12 )
{
     uint8_t *Sy  = frame->vo_frame.base[0];
     uint8_t *Su  = frame->vo_frame.base[1];
     uint8_t *Sv  = frame->vo_frame.base[2];
     uint8_t *Dy  = frame->out_plane[0];
     uint8_t *Du  = frame->out_plane[1];
     uint8_t *Dv  = frame->out_plane[2];
     int      set = frame->mixer_set;

     if (set & (MF_B | MF_C)) {
          __asm__ __volatile__(
               "movq      proc_table, %%mm2\n\t"    // mm2 = proc_table.mmx.lm_sub
               "movq      proc_table+24, %%mm3\n\t" // mm3 = proc_table.mmx.lm_cfc
               "movq      proc_table+8, %%mm4\n\t"  // mm4 = proc_table.mmx.lm_add
               "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
               ".align 16\n"
               "1:\n\t"
               "movq      (%1), %%mm0\n\t"          // mm0: y7 y6 y5 y4 y3 y2 y1 y0
               "movq      %%mm0, %%mm1\n\t"         // mm1: y7 y6 y5 y4 y3 y2 y1 y0
               "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 y3 00 y2 00 y1 00 y0
               "punpckhbw %%mm7, %%mm1\n\t"         // mm1: 00 y7 00 y6 00 y5 00 y4
               "psubw     %%mm2, %%mm0\n\t"         // y[0-3] - proc_table.mmx.lm_sub
               "psubw     %%mm2, %%mm1\n\t"         // y[4-7] - proc_table.mmx.lm_sub
               "psllw     $3, %%mm0\n\t"            // y[0-3] << 3
               "pmulhw    %%mm3, %%mm0\n\t"         // y[0-3] * proc_table.mmx.lm_cfc
               "psllw     $3, %%mm1\n\t"            // y[4-7] << 3
               "pmulhw    %%mm3, %%mm1\n\t"         // y[4-7] * proc_table.mmx.lm_cfc
               "paddw     %%mm4, %%mm0\n\t"         // y[0-3] + proc_table.mmx.lm_add
               "paddw     %%mm4, %%mm1\n\t"         // y[4-7] + proc_table.mmx.lm_add
               "packuswb  %%mm1, %%mm0\n\t"         // mm0: y7 y6 y5 y4 y3 y2 y1 y0
               "movq      %%mm0, (%0)\n\t"
               "addl      $8, %0\n\t"
               "addl      $8, %1\n\t"
               "decl      %2\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Dy), "=&S" (Sy)
               : "c" (frame->area/8), "0" (Dy), "1" (Sy)
               :  "memory");
     }

     if (set & MF_S) {
          __asm__ __volatile__(
               "movq      proc_table+16, %%mm2\n\t" // mm2 = proc_table.mmx.uv_sub
               "movq      proc_table+32, %%mm3\n\t" // mm3 = proc_table.mmx.uv_cfc
               "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
               ".align 16\n"
               "1:\n\t"
               "movd      (%2), %%mm0\n\t"          // mm0: 00 00 00 00 u3 u2 u1 u0
               "movd      (%3), %%mm1\n\t"          // mm1: 00 00 00 00 v3 v2 v1 v0
               "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 u3 00 u2 00 u1 00 u0
               "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 v3 00 v2 00 v1 00 v0
               "psubw     %%mm2, %%mm0\n\t"         // u - proc_table.mmx.uv_sub
               "psubw     %%mm2, %%mm1\n\t"         // v - proc_table.mmx.uv_sub
               "psllw     $3, %%mm0\n\t"            // u << 3 
               "pmulhw    %%mm3, %%mm0\n\t"         // u * proc_table.mmx.uv_cfc
               "psllw     $3, %%mm1\n\t"            // v << 3
               "pmulhw    %%mm3, %%mm1\n\t"         // v * proc_table.mmx.uv_cfc
               "paddw     %%mm2, %%mm0\n\t"         // u + proc_table.mmx.uv_sub
               "paddw     %%mm2, %%mm1\n\t"         // v + proc_table.mmx.uv_sub
               "packuswb  %%mm1, %%mm0\n\t"         // mm0: v3 v2 v1 v0 u3 u2 u1 u0
               "movd      %%mm0, (%0)\n\t"
               "punpckhdq %%mm0, %%mm0\n\t"         // mm0: v3 v2 v1 v0 v3 v2 v1 v0
               "movd      %%mm0, (%1)\n\t"
               "addl      $4, %0\n\t"
               "addl      $4, %1\n\t"
               "addl      $4, %2\n\t"
               "addl      $4, %3\n\t"
               "decl      %4\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&r" (Du), "=&r" (Dv), "=&r" (Su), "=&r" (Sv)
               : "c" (frame->area/16), "0" (Du), "1" (Dv), "2" (Su), "3" (Sv)
               : "memory");

          if (frame->area & 8) {
               *Du = proc_table.uv[*Du];
               *Dv = proc_table.uv[*Dv];
          }
     } 
}

static
DFB_PFUNCTION( yv12, nv12 )
{
     uint8_t  *Sy   = frame->vo_frame.base[0];
     uint8_t  *Su   = frame->vo_frame.base[1];
     uint8_t  *Sv   = frame->vo_frame.base[2];
     uint8_t  *Dy   = frame->out_plane[0];
     uint16_t *Duv  = (uint16_t*) frame->out_plane[1];
     int       set  = frame->mixer_set;
 
     if (set & (MF_B | MF_C)) {
          __asm__ __volatile__(
               "movq      proc_table, %%mm2\n\t"    // mm2 = proc_table.mmx.lm_sub
               "movq      proc_table+24, %%mm3\n\t" // mm3 = proc_table.mmx.lm_cfc
               "movq      proc_table+8, %%mm4\n\t"  // mm4 = proc_table.mmx.lm_add
               "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
               ".align 16\n"
               "1:\n\t"
               "movq      (%1), %%mm0\n\t"          // mm0: y7 y6 y5 y4 y3 y2 y1 y0
               "movq      %%mm0, %%mm1\n\t"         // mm1: y7 y6 y5 y4 y3 y2 y1 y0
               "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 y3 00 y2 00 y1 00 y0
               "punpckhbw %%mm7, %%mm1\n\t"         // mm1: 00 y7 00 y6 00 y5 00 y4
               "psubw     %%mm2, %%mm0\n\t"         // y[0-3] - proc_table.mmx.lm_sub
               "psubw     %%mm2, %%mm1\n\t"         // y[4-7] - proc_table.mmx.lm_sub
               "psllw     $3, %%mm0\n\t"            // y[0-3] << 3
               "pmulhw    %%mm3, %%mm0\n\t"         // y[0-3] * proc_table.mmx.lm_cfc
               "psllw     $3, %%mm1\n\t"            // y[4-7] << 3
               "pmulhw    %%mm3, %%mm1\n\t"         // y[4-7] * proc_table.mmx.lm_cfc
               "paddw     %%mm4, %%mm0\n\t"         // y[0-3] + proc_table.mmx.lm_add
               "paddw     %%mm4, %%mm1\n\t"         // y[4-7] + proc_table.mmx.lm_add
               "packuswb  %%mm1, %%mm0\n\t"         // mm0: y7 y6 y5 y4 y3 y2 y1 y0
               "movq      %%mm0, (%0)\n\t"
               "addl      $8, %0\n\t"
               "addl      $8, %1\n\t"
               "decl      %2\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Dy), "=&S" (Sy)
               : "c" (frame->area/8), "0" (Dy), "1" (Sy)
               :  "memory");
     }

     if (set & MF_S) {
          __asm__ __volatile__(
               "movq      proc_table+16, %%mm2\n\t" // mm2 = proc_table.mmx.uv_sub
               "movq      proc_table+32, %%mm3\n\t" // mm3 = proc_table.mmx.uv_cfc
               "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
               ".align 16\n"
               "1:\n\t"
               "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 u3 u2 u1 u0
               "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 v3 v2 v1 v0 
               "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 u3 00 u2 00 u1 00 u0
               "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 v3 00 v2 00 v1 00 v0
               "psubw     %%mm2, %%mm0\n\t"         // u - proc_table.mmx.uv_sub
               "psubw     %%mm2, %%mm1\n\t"         // v - proc_table.mmx.uv_sub
               "psllw     $3, %%mm0\n\t"            // u << 3 
               "pmulhw    %%mm3, %%mm0\n\t"         // u * proc_table.mmx.uv_cfc
               "psllw     $3, %%mm1\n\t"            // v << 3
               "pmulhw    %%mm3, %%mm1\n\t"         // v * proc_table.mmx.uv_cfc
               "paddw     %%mm2, %%mm0\n\t"         // u + proc_table.mmx.uv_sub
               "paddw     %%mm2, %%mm1\n\t"         // v + proc_table.mmx.uv_sub
               "packuswb  %%mm0, %%mm0\n\t"         // mm0: u3 u2 u1 u0 u3 u2 u1 u0
               "packuswb  %%mm1, %%mm1\n\t"         // mm1: v3 v2 v1 v0 v3 v2 v1 v0
               "punpcklbw %%mm1, %%mm0\n\t"         // mm0: v3 u3 v2 u2 v1 u1 v0 u0
               "movq      %%mm0, (%0)\n\t"
               "addl      $8, %0\n\t"
               "addl      $4, %1\n\t"
               "addl      $4, %2\n\t"
               "decl      %3\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Duv), "=&r" (Su), "=&r" (Sv)
               : "c" (frame->area/16), "0" (Duv), "1" (Su), "2" (Sv)
               : "memory");
     }
     else {
           __asm__ __volatile__(
               ".align 16\n"
               "1:\n\t"
               "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 u3 u2 u1 u0
               "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 v3 v2 v1 v0
               "punpcklbw %%mm1, %%mm0\n\t"         // mm0: v3 u3 v2 u2 v1 u1 v0 u0
               "movq      %%mm0, (%0)\n\t"
               "addl      $8, %0\n\t"
               "addl      $4, %1\n\t"
               "addl      $4, %2\n\t"
               "decl      %3\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Duv), "=&r" (Su), "=&r" (Sv)
               : "c" (frame->area/16), "0" (Duv), "1" (Su), "2" (Sv)
               : "memory");
     }

     if (frame->area & 8)
          *Duv = proc_table.uv[*Su] | (proc_table.uv[*Sv] << 8);
}

static
DFB_PFUNCTION( yv12, nv21 )
{
     uint8_t  *Sy   = frame->vo_frame.base[0];
     uint8_t  *Su   = frame->vo_frame.base[1];
     uint8_t  *Sv   = frame->vo_frame.base[2];
     uint8_t  *Dy   = frame->out_plane[0];
     uint16_t *Dvu  = (uint16_t*) frame->out_plane[1];
     int       set  = frame->mixer_set;
 
     if (set & (MF_B | MF_C)) {
          __asm__ __volatile__(
               "movq      proc_table, %%mm2\n\t"    // mm2 = proc_table.mmx.lm_sub
               "movq      proc_table+24, %%mm3\n\t" // mm3 = proc_table.mmx.lm_cfc
               "movq      proc_table+8, %%mm4\n\t"  // mm4 = proc_table.mmx.lm_add
               "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
               ".align 16\n"
               "1:\n\t"
               "movq      (%1), %%mm0\n\t"          // mm0: y7 y6 y5 y4 y3 y2 y1 y0
               "movq      %%mm0, %%mm1\n\t"         // mm1: y7 y6 y5 y4 y3 y2 y1 y0
               "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 y3 00 y2 00 y1 00 y0
               "punpckhbw %%mm7, %%mm1\n\t"         // mm1: 00 y7 00 y6 00 y5 00 y4
               "psubw     %%mm2, %%mm0\n\t"         // y[0-3] - proc_table.mmx.lm_sub
               "psubw     %%mm2, %%mm1\n\t"         // y[4-7] - proc_table.mmx.lm_sub
               "psllw     $3, %%mm0\n\t"            // y[0-3] << 3
               "pmulhw    %%mm3, %%mm0\n\t"         // y[0-3] * proc_table.mmx.lm_cfc
               "psllw     $3, %%mm1\n\t"            // y[4-7] << 3
               "pmulhw    %%mm3, %%mm1\n\t"         // y[4-7] * proc_table.mmx.lm_cfc
               "paddw     %%mm4, %%mm0\n\t"         // y[0-3] + proc_table.mmx.lm_add
               "paddw     %%mm4, %%mm1\n\t"         // y[4-7] + proc_table.mmx.lm_add
               "packuswb  %%mm1, %%mm0\n\t"         // mm0: y7 y6 y5 y4 y3 y2 y1 y0
               "movq      %%mm0, (%0)\n\t"
               "addl      $8, %0\n\t"
               "addl      $8, %1\n\t"
               "decl      %2\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Dy), "=&S" (Sy)
               : "c" (frame->area/8), "0" (Dy), "1" (Sy)
               :  "memory");
     }

     if (set & MF_S) {
          __asm__ __volatile__(
               "movq      proc_table+16, %%mm2\n\t" // mm2 = proc_table.mmx.uv_sub
               "movq      proc_table+32, %%mm3\n\t" // mm3 = proc_table.mmx.uv_cfc
               "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
               ".align 16\n"
               "1:\n\t"
               "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 u3 u2 u1 u0
               "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 v3 v2 v1 v0 
               "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 u3 00 u2 00 u1 00 u0
               "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 v3 00 v2 00 v1 00 v0
               "psubw     %%mm2, %%mm0\n\t"         // u - proc_table.mmx.uv_sub
               "psubw     %%mm2, %%mm1\n\t"         // v - proc_table.mmx.uv_sub
               "psllw     $3, %%mm0\n\t"            // u << 3 
               "pmulhw    %%mm3, %%mm0\n\t"         // u * proc_table.mmx.uv_cfc
               "psllw     $3, %%mm1\n\t"            // v << 3
               "pmulhw    %%mm3, %%mm1\n\t"         // v * proc_table.mmx.uv_cfc
               "paddw     %%mm2, %%mm0\n\t"         // u + proc_table.mmx.uv_sub
               "paddw     %%mm2, %%mm1\n\t"         // v + proc_table.mmx.uv_sub
               "packuswb  %%mm0, %%mm0\n\t"         // mm0: u3 u2 u1 u0 u3 u2 u1 u0
               "packuswb  %%mm1, %%mm1\n\t"         // mm1: v3 v2 v1 v0 v3 v2 v1 v0
               "punpcklbw %%mm0, %%mm1\n\t"         // mm1: u3 v3 u2 v2 u1 v1 u0 v0
               "movq      %%mm1, (%0)\n\t"
               "addl      $8, %0\n\t"
               "addl      $4, %1\n\t"
               "addl      $4, %2\n\t"
               "decl      %3\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Dvu), "=&r" (Su), "=&r" (Sv)
               : "c" (frame->area/16), "0" (Dvu), "1" (Su), "2" (Sv)
               : "memory");
     }
     else {
           __asm__ __volatile__(
               ".align 16\n"
               "1:\n\t"
               "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 u3 u2 u1 u0
               "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 v3 v2 v1 v0
               "punpcklbw %%mm0, %%mm1\n\t"         // mm1: u3 v3 u2 v2 u1 v1 u0 v0
               "movq      %%mm1, (%0)\n\t"
               "addl      $8, %0\n\t"
               "addl      $4, %1\n\t"
               "addl      $4, %2\n\t"
               "decl      %3\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Dvu), "=&r" (Su), "=&r" (Sv)
               : "c" (frame->area/16), "0" (Dvu), "1" (Su), "2" (Sv)
               : "memory");
     }

     if (frame->area & 8)
          *Dvu = proc_table.uv[*Sv] | (proc_table.uv[*Su] << 8);
}

static
DFB_PFUNCTION( yv12, nv16 )
{
     uint8_t  *Sy   = frame->vo_frame.base[0];
     uint8_t  *Su   = frame->vo_frame.base[1];
     uint8_t  *Sv   = frame->vo_frame.base[2];
     uint8_t  *Dy   = frame->out_plane[0];
     uint16_t *Duv  = (uint16_t*) frame->out_plane[1]; 
     int       set  = frame->mixer_set;

     if (set & (MF_B | MF_C)) {
          __asm__ __volatile__(
               "movq      proc_table, %%mm2\n\t"    // mm2 = proc_table.mmx.lm_sub
               "movq      proc_table+24, %%mm3\n\t" // mm3 = proc_table.mmx.lm_cfc
               "movq      proc_table+8, %%mm4\n\t"  // mm4 = proc_table.mmx.lm_add
               "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
               ".align 16\n"
               "1:\n\t"
               "movq      (%1), %%mm0\n\t"          // mm0: y7 y6 y5 y4 y3 y2 y1 y0
               "movq      %%mm0, %%mm1\n\t"         // mm1: y7 y6 y5 y4 y3 y2 y1 y0
               "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 y3 00 y2 00 y1 00 y0
               "punpckhbw %%mm7, %%mm1\n\t"         // mm1: 00 y7 00 y6 00 y5 00 y4
               "psubw     %%mm2, %%mm0\n\t"         // y[0-3] - proc_table.mmx.lm_sub
               "psubw     %%mm2, %%mm1\n\t"         // y[4-7] - proc_table.mmx.lm_sub
               "psllw     $3, %%mm0\n\t"            // y[0-3] << 3
               "pmulhw    %%mm3, %%mm0\n\t"         // y[0-3] * proc_table.mmx.lm_cfc
               "psllw     $3, %%mm1\n\t"            // y[4-7] << 3
               "pmulhw    %%mm3, %%mm1\n\t"         // y[4-7] * proc_table.mmx.lm_cfc
               "paddw     %%mm4, %%mm0\n\t"         // y[0-3] + proc_table.mmx.lm_add
               "paddw     %%mm4, %%mm1\n\t"         // y[4-7] + proc_table.mmx.lm_add
               "packuswb  %%mm1, %%mm0\n\t"         // mm0: y7 y6 y5 y4 y3 y2 y1 y0
               "movq      %%mm0, (%0)\n\t"
               "addl      $8, %0\n\t"
               "addl      $8, %1\n\t"
               "decl      %2\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Dy), "=&S" (Sy)
               : "c" (frame->area/8), "0" (Dy), "1" (Sy)
               :  "memory");
     }

     if (set & MF_S) {
          __asm__ __volatile__(
               "movq      proc_table+16, %%mm2\n\t" // mm2 = proc_table.mmx.uv_sub
               "movq      proc_table+32, %%mm3\n\t" // mm3 = proc_table.mmx.uv_cfc
               "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
               ".align 16\n"
               "1:\n\t"
               "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 u3 u2 u1 u0
               "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 v3 v2 v1 v0 
               "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 u3 00 u2 00 u1 00 u0
               "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 v3 00 v2 00 v1 00 v0
               "psubw     %%mm2, %%mm0\n\t"         // u - proc_table.mmx.uv_sub
               "psubw     %%mm2, %%mm1\n\t"         // v - proc_table.mmx.uv_sub
               "psllw     $3, %%mm0\n\t"            // u << 3 
               "pmulhw    %%mm3, %%mm0\n\t"         // u * proc_table.mmx.uv_cfc
               "psllw     $3, %%mm1\n\t"            // v << 3
               "pmulhw    %%mm3, %%mm1\n\t"         // v * proc_table.mmx.uv_cfc
               "paddw     %%mm2, %%mm0\n\t"         // u + proc_table.mmx.uv_sub
               "paddw     %%mm2, %%mm1\n\t"         // v + proc_table.mmx.uv_sub
               "packuswb  %%mm0, %%mm0\n\t"         // mm0: u3 u2 u1 u0 u3 u2 u1 u0
               "packuswb  %%mm1, %%mm1\n\t"         // mm1: v3 v2 v1 v0 v3 v2 v1 v0
               "punpcklbw %%mm1, %%mm0\n\t"         // mm0: v3 u3 v2 u2 v1 u1 v0 u0
               "movq      %%mm0, (%0)\n\t"
               "movq      %%mm0, (%0,%3)\n\t"
               "addl      $8, %0\n\t"
               "addl      $4, %1\n\t"
               "addl      $4, %2\n\t"
               "decl      %3\n\t"
               "jnz       1b\n\t"
               "testl     $4, %3\n\t"
               "jz        2f\n\t"
               "movb      (%1), %%cl\n\t"  /* FIXME: apply correction instead of moving bytes */
               "movb      (%2), %%ch\n\t"
               "movw      %%cx, (%0)\n\t"
               "movw      %%cx, (%0,%3)\n\t"
               "addl      $2, %0\n\t"
               "incl      %1\n\t"
               "incl      %2\n\t"
               "2:\n\t"
               "addl      %3, %0\n\t"
               "movl      %3, %4\n\t"
               "shrl      $3, %4\n\t"
               "decl      %5\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Duv), "=&r" (Su), "=&r" (Sv)
               : "q" (frame->width), "c" (frame->width/8), "r" (frame->height/2),
                 "0" (Duv), "1" (Su), "2" (Sv)
               : "memory");
     }
     else {
           __asm__ __volatile__(
               ".align 16\n"
               "1:\n\t"
               "movd      (%1), %%mm0\n\t"          // mm0: 00 00 00 00 u3 u2 u1 u0
               "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 v3 v2 v1 v0
               "punpcklbw %%mm1, %%mm0\n\t"         // mm0: v3 u3 v2 u2 v1 u1 v0 u0
               "movq      %%mm0, (%0)\n\t"
               "movq      %%mm0, (%0,%3)\n\t"
               "addl      $8, %0\n\t"
               "addl      $4, %1\n\t"
               "addl      $4, %2\n\t"
               "decl      %4\n\t"
               "jnz       1b\n\t"
               "testl     $4, %3\n\t"
               "jz        2f\n\t"
               "movb      (%1), %%cl\n\t"
               "movb      (%2), %%ch\n\t"
               "movw      %%cx, (%0)\n\t"
               "movw      %%cx, (%0,%3)\n\t"
               "addl      $2, %0\n\t"
               "incl      %1\n\t"
               "incl      %2\n\t"
               "2:\n\t"
               "addl      %3, %0\n\t"
               "movl      %3, %4\n\t"
               "shrl      $3, %4\n\t"
               "decl      %5\n\t"
               "jnz       1b\n\t"
               "emms"
               : "=&D" (Duv), "=&r" (Su), "=&r" (Sv)
               : "q" (frame->width), "c" (frame->width/8), "r" (frame->height/2),
                 "0" (Duv), "1" (Su), "2" (Sv)
               : "memory");
     }
}

/* TODO: optimize the following functions */

static
DFB_PFUNCTION( yv12, rgb332 )
{
     uint8_t *Sy = frame->vo_frame.base[0];
     uint8_t *Su = frame->vo_frame.base[1];
     uint8_t *Sv = frame->vo_frame.base[2];
     uint8_t *D  = frame->out_plane[0]; 
     int      n  = frame->height/2;
     
     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movd      (%1), %%mm3\n\t"          // mm3: 00 00 00 00 y03 y02 y01 y00
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 y03 00 y02 00 y01 00 y00
          "psubw     proc_table, %%mm3\n\t"    // y0X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm3\n\t"            // y0X << 3
          "pmulhw    proc_table+24, %%mm3\n\t" // y0X * proc_table.mmx.lm_cfc
          "movd      (%1,%4), %%mm2\n\t"       // mm2: 00 00 00 00 y13 y12 y11 y10
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 y13 00 y12 00 y11 00 y10
          "psubw     proc_table, %%mm2\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y1X * proc_table.mmx.lm_cfc
          "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 u3 u2 u1 u0
          "punpcklbw %%mm1, %%mm1\n\t"         // mm1: u3 u3 u2 u2 u1 u1 u0 u0
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 u1 00 u1 00 u0 00 u0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "psllw     $3, %%mm1\n\t"            // u << 3
          "movd      (%3), %%mm0\n\t"          // mm0: 00 00 00 00 v3 v2 v1 v0
          "punpcklbw %%mm0, %%mm0\n\t"         // mm0: v3 v3 v2 v2 v1 v1 v0 v0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v1 00 v1 00 v0 00 v0
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // v << 3
          "movq      %%mm0, %%mm4\n\t"         // mm4: 00 v1 00 v1 00 v0 00 v0
          "pmulhw    proc_table+40, %%mm4\n\t" // v red
          "movq      %%mm4, %%mm5\n\t"
          "paddw     %%mm3, %%mm4\n\t"         // mm4: XX r03 XX r02 XX r01 XX r00
          "paddw     %%mm2, %%mm5\n\t"         // mm5: XX r13 XX r12 XX r11 XX r10
          "packuswb  %%mm5, %%mm4\n\t"         // mm4: r13 r12 r11 r10 r03 r02 r01 r00
          "pand      b3mask, %%mm4\n\t"        // red
          "movq      %%mm1, %%mm5\n\t"         // mm5: 00 u1 00 u1 00 u0 00 u0
          "pmulhw    proc_table+64, %%mm5\n\t" // u blue
          "movq      %%mm5, %%mm6\n\t"
          "paddw     %%mm3, %%mm5\n\t"         // mm5: XX b03 XX b02 XX b01 XX b00
          "paddw     %%mm2, %%mm6\n\t"         // mm6: XX b13 XX b12 XX b11 XX b00
          "packuswb  %%mm6, %%mm5\n\t"         // mm5: b13 b12 b11 b10 b03 b02 b01 b00
          "pmulhw    proc_table+48, %%mm0\n\t" // v green
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "paddw     %%mm1, %%mm0\n\t"         // u+v green
          "paddw     %%mm0, %%mm3\n\t"         // mm3: XX g03 XX g02 XX g01 XX g00
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g13 XX g12 XX g11 XX g10
          "packuswb  %%mm2, %%mm3\n\t"         // mm3: g13 g12 g11 g10 g03 g02 g01 g00
          "pand      b3mask, %%mm3\n\t"
          "movq      %%mm4, %%mm0\n\t"         // mm0: r13 r12 r11 r10 r03 r02 r01 r00
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 r03 00 r02 00 r01 00 r00
          "movq      %%mm5, %%mm1\n\t"         // mm1: b13 b12 b11 b10 b03 b02 b01 b00
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 b03 00 b02 00 b01 00 b00
          "psrlw     $6, %%mm1\n\t"            // blue0
          "por       %%mm1, %%mm0\n\t"         // blue0 | red0
          "movq      %%mm3, %%mm1\n\t"         // mm1: g13 g12 g11 g10 g03 g02 g01 g00
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 g03 00 g02 00 g01 00 g00
          "psrlw     $3, %%mm1\n\t"            // green0
          "por       %%mm1, %%mm0\n\t"         // blue0 | green0 | red0
          "packuswb  %%mm0, %%mm0\n\t"         // pixels (line 0)
          "movd      %%mm0, (%0)\n\t"
          "punpckhbw %%mm7, %%mm4\n\t"         // mm4: 00 r13 00 r12 00 r11 00 r10
          "punpckhbw %%mm7, %%mm5\n\t"         // mm5: 00 b13 00 b12 00 b11 00 b10
          "psrlw     $6, %%mm5\n\t"            // blue1
          "por       %%mm5, %%mm4\n\t"         // blue1 | red1
          "punpckhbw %%mm7, %%mm3\n\t"         // mm3: 00 g13 00 g12 00 g11 00 g10
          "psrlw     $3, %%mm3\n\t"            // green1
          "por       %%mm3, %%mm4\n\t"         // blue1 | green1 | red1
          "packuswb  %%mm4, %%mm4\n\t"         // pixels (line 1)
          "movd      %%mm4, (%0,%4)\n\t"
          "addl      $4, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       1b\n\t"
          "movl      %4, %5\n\t"
          "shrl      $2, %5\n\t"
          "addl      %4, %0\n\t"
          "addl      %4, %1\n\t"
          "decl      %6\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&r" (Sy), "=&r" (Su), "=&r" (Sv)
          : "q" (frame->width), "c" (frame->width/4), "m" (n),
            "0" (D), "1" (Sy), "2" (Su), "3" (Sv)
          : "memory");
}

static
DFB_PFUNCTION( yv12, argb1555 )
{
     uint8_t *Sy = frame->vo_frame.base[0];
     uint8_t *Su = frame->vo_frame.base[1];
     uint8_t *Sv = frame->vo_frame.base[2];
     uint8_t *D  = frame->out_plane[0];
     int      n  = frame->height/2;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movd      (%1), %%mm3\n\t"          // mm3: 00 00 00 00 y03 y02 y01 y00
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 y03 00 y02 00 y01 00 y00
          "psubw     proc_table, %%mm3\n\t"    // y0X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm3\n\t"            // y0X << 3
          "pmulhw    proc_table+24, %%mm3\n\t" // y0X * proc_table.mmx.lm_cfc
          "movd      (%1,%4), %%mm2\n\t"       // mm2: 00 00 00 00 y13 y12 y11 y10
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 y13 00 y12 00 y11 00 y10
          "psubw     proc_table, %%mm2\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y1X * proc_table.mmx.lm_cfc
          "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 u3 u2 u1 u0
          "punpcklbw %%mm1, %%mm1\n\t"         // mm1: u3 u3 u2 u2 u1 u1 u0 u0
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 u1 00 u1 00 u0 00 u0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "psllw      $3, %%mm1\n\t"           // u << 3
          "movd      (%3), %%mm0\n\t"          // mm0: 00 00 00 00 v3 v2 v1 v0
          "punpcklbw %%mm0, %%mm0\n\t"         // mm0: v3 v3 v2 v2 v1 v1 v0 v0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v1 00 v1 00 v0 00 v0
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // v << 3
          "movq      %%mm0, %%mm4\n\t"         // mm4: 00 v1 00 v1 00 v0 00 v0
          "pmulhw    proc_table+40, %%mm4\n\t" // v red
          "movq      %%mm4, %%mm5\n\t"
          "paddw     %%mm3, %%mm4\n\t"         // mm4: XX r03 XX r02 XX r01 XX r00
          "paddw     %%mm2, %%mm5\n\t"         // mm5: XX r13 XX r12 XX r11 XX r10
          "packuswb  %%mm5, %%mm4\n\t"         // mm4: r13 r12 r11 r10 r03 r02 r01 r00
          "pand      b5mask, %%mm4\n\t"
          "movq      %%mm1, %%mm5\n\t"         // mm5: 00 u1 00 u1 00 u0 00 u0
          "pmulhw    proc_table+64, %%mm5\n\t" // u blue
          "movq      %%mm5, %%mm6\n\t"
          "paddw     %%mm3, %%mm5\n\t"         // mm5: XX b03 XX b02 XX b01 XX b00
          "paddw     %%mm2, %%mm6\n\t"         // mm6: XX b13 XX b12 XX b11 XX b00
          "packuswb  %%mm6, %%mm5\n\t"         // mm5: b13 b12 b11 b10 b03 b02 b01 b00
          "pmulhw    proc_table+48, %%mm0\n\t" // v green
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "paddw     %%mm1, %%mm0\n\t"         // u+v green
          "paddw     %%mm0, %%mm3\n\t"         // mm3: XX g03 XX g02 XX g01 XX g00
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g13 XX g12 XX g11 XX g10
          "packuswb  %%mm2, %%mm3\n\t"         // mm3: g13 g12 g11 g10 g03 g02 g01 g00
          "pand      b5mask, %%mm3\n\t"
          "movq      %%mm4, %%mm0\n\t"         // mm0: r13 r12 r11 r10 r03 r02 r01 r00
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 r03 00 r02 00 r01 00 r00
          "psllw     $7, %%mm0\n\t"            // red0
          "movq      %%mm5, %%mm1\n\t"         // mm1: b13 b12 b11 b10 b03 b02 b01 b00
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 b03 00 b02 00 b01 00 b00
          "psrlw     $3, %%mm1\n\t"            // blue0
          "por       %%mm1, %%mm0\n\t"         // blue0 | red0
          "movq      %%mm3, %%mm1\n\t"         // mm1: g13 g12 g11 g10 g03 g02 g01 g00
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 g03 00 g02 00 g01 00 g00
          "psllw     $2, %%mm1\n\t"            // green0
          "por       %%mm1, %%mm0\n\t"         // blue0 | green0 | red0
          "por       a1mask, %%mm0\n\t"        // pixels (line 0)
          "movq      %%mm0, (%0)\n\t"
          "punpckhbw %%mm7, %%mm4\n\t"         // mm4: 00 r13 00 r12 00 r11 00 r10
          "psllw     $7, %%mm4\n\t"            // red1
          "punpckhbw %%mm7, %%mm5\n\t"         // mm5: 00 b13 00 b12 00 b11 00 b10
          "psrlw     $3, %%mm5\n\t"            // blue1
          "por       %%mm5, %%mm4\n\t"         // blue1 | red1
          "punpckhbw %%mm7, %%mm3\n\t"         // mm3: 00 g13 00 g12 00 g11 00 g10
          "psllw     $2, %%mm3\n\t"            // green1
          "por       %%mm3, %%mm4\n\t"         // blue1 | green1 | red1
          "por       a1mask, %%mm4\n\t"        // pixels (line 1)
          "movq      %%mm4, (%0,%4,2)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       1b\n\t"
          "movl      %4, %5\n\t"
          "shll      $1, %5\n\t"
          "addl      %5, %0\n\t"
          "addl      %4, %1\n\t"
          "shrl      $3, %5\n\t"
          "decl      %6\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&r" (Sy), "=&r" (Su), "=&r" (Sv)
          : "q" (frame->width), "c" (frame->width/4), "m" (n),
            "0" (D), "1" (Sy), "2" (Su), "3" (Sv)
          : "memory");
}

static
DFB_PFUNCTION( yv12, rgb16 )
{
     uint8_t *Sy = frame->vo_frame.base[0];
     uint8_t *Su = frame->vo_frame.base[1];
     uint8_t *Sv = frame->vo_frame.base[2];
     uint8_t *D  = frame->out_plane[0];
     int      n  = frame->height/2;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movd      (%1), %%mm3\n\t"          // mm3: 00 00 00 00 y03 y02 y01 y00
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 y03 00 y02 00 y01 00 y00
          "psubw     proc_table, %%mm3\n\t"    // y0X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm3\n\t"            // y0X << 3
          "pmulhw    proc_table+24, %%mm3\n\t" // y0X * proc_table.mmx.lm_cfc
          "movd      (%1,%4), %%mm2\n\t"       // mm2: 00 00 00 00 y13 y12 y11 y10
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 y13 00 y12 00 y11 00 y10
          "psubw     proc_table, %%mm2\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y1X * proc_table.mmx.lm_cfc
          "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 u3 u2 u1 u0
          "punpcklbw %%mm1, %%mm1\n\t"         // mm1: u3 u3 u2 u2 u1 u1 u0 u0
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 u1 00 u1 00 u0 00 u0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "psllw     $3, %%mm1\n\t"            // u << 3
          "movd      (%3), %%mm0\n\t"          // mm0: 00 00 00 00 v3 v2 v1 v0
          "punpcklbw %%mm0, %%mm0\n\t"         // mm0: v3 v3 v2 v2 v1 v1 v0 v0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v1 00 v1 00 v0 00 v0
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // v << 3
          "movq      %%mm0, %%mm4\n\t"         // mm4: 00 v1 00 v1 00 v0 00 v0
          "pmulhw    proc_table+40, %%mm4\n\t" // v red
          "movq      %%mm4, %%mm5\n\t"
          "paddw     %%mm3, %%mm4\n\t"         // mm4: XX r03 XX r02 XX r01 XX r00
          "paddw     %%mm2, %%mm5\n\t"         // mm5: r13 XX r12 XX r11 XX r10
          "packuswb  %%mm5, %%mm4\n\t"         // mm4: r13 r12 r11 r10 r03 r02 r01 r00
          "pand      b5mask, %%mm4\n\t"
          "movq      %%mm1, %%mm5\n\t"         // mm5: 00 u1 00 u1 00 u0 00 u0
          "pmulhw    proc_table+64, %%mm5\n\t" // u blue
          "movq      %%mm5, %%mm6\n\t"
          "paddw     %%mm3, %%mm5\n\t"         // mm5: XX b03 XX b02 XX b01 XX b00
          "paddw     %%mm2, %%mm6\n\t"         // mm6: XX b13 XX b12 XX b11 XX b00
          "packuswb  %%mm6, %%mm5\n\t"         // mm5: b13 b12 b11 b10 b03 b02 b01 b00
          "pmulhw    proc_table+48, %%mm0\n\t" // v green
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "paddw     %%mm1, %%mm0\n\t"         // u+v green
          "paddw     %%mm0, %%mm3\n\t"         // mm3: XX g03 XX g02 XX g01 XX g00
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g13 XX g12 XX g11 XX g10
          "packuswb  %%mm2, %%mm3\n\t"         // mm3: g13 g12 g11 g10 g03 g02 g01 g00
          "pand      b6mask, %%mm3\n\t"
          "movq      %%mm4, %%mm0\n\t"         // mm0: r13 r12 r11 r10 r03 r02 r01 r00
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 r03 00 r02 00 r01 00 r00
          "psllw     $8, %%mm0\n\t"            // red0
          "movq      %%mm5, %%mm1\n\t"         // mm1: b13 b12 b11 b10 b03 b02 b01 b00
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 b03 00 b02 00 b01 00 b00
          "psrlw     $3, %%mm1\n\t"            // blue0
          "por       %%mm1, %%mm0\n\t"         // blue0 | red0
          "movq      %%mm3, %%mm1\n\t"         // mm1: g13 g12 g11 g10 g03 g02 g01 g00
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 g03 00 g02 00 g01 00 g00
          "psllw     $3, %%mm1\n\t"            // green0
          "por       %%mm1, %%mm0\n\t"         // pixels (line 0)
          "movq      %%mm0, (%0)\n\t"
          "punpckhbw %%mm7, %%mm4\n\t"         // mm4: 00 r13 00 r12 00 r11 00 r10
          "psllw     $8, %%mm4\n\t"            // red1
          "punpckhbw %%mm7, %%mm5\n\t"         // mm5: 00 b13 00 b12 00 b11 00 b10
          "psrlw     $3, %%mm5\n\t"            // blue1
          "por       %%mm5, %%mm4\n\t"         // blue1 | red1
          "punpckhbw %%mm7, %%mm3\n\t"         // mm3: 00 g13 00 g12 00 g11 00 g10
          "psllw     $3, %%mm3\n\t"            // green1
          "por       %%mm3, %%mm4\n\t"         // pixels (line 1)
          "movq      %%mm4, (%0,%4,2)\n\t"
          "addl      $8, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %5\n\t"
          "jnz       1b\n\t"
          "movl      %4, %5\n\t" 
          "shll      $1, %5\n\t"
          "addl      %5, %0\n\t"
          "addl      %4, %1\n\t"
          "shrl      $3, %5\n\t"
          "decl      %6\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&r" (Sy), "=&r" (Su), "=&r" (Sv)
          : "q" (frame->width), "c" (frame->width/4), "m" (n),
            "0" (D), "1" (Sy), "2" (Su), "3" (Sv)
          : "memory");
}

static
DFB_PFUNCTION( yv12, rgb24 )
{
     uint8_t *Sy = frame->vo_frame.base[0];
     uint8_t *Su = frame->vo_frame.base[1];
     uint8_t *Sv = frame->vo_frame.base[2];
     uint8_t *D  = frame->out_plane[0];
     int      l  = frame->width/4;
     int      n  = frame->height/2;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movd      (%1), %%mm3\n\t"          // mm3: 00 00 00 00 y03 y02 y01 y00
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 y03 00 y02 00 y01 00 y00
          "psubw     proc_table, %%mm3\n\t"    // y0X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm3\n\t"            // y0X << 3
          "pmulhw    proc_table+24, %%mm3\n\t" // y0X * proc_table.mmx.lm_cfc
          "movd      (%1,%4), %%mm2\n\t"       // mm2: 00 00 00 00 y13 y12 y11 y10
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 y13 00 y12 00 y11 00 y10
          "psubw     proc_table, %%mm2\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y1X * proc_table.mmx.lm_cfc
          "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 u3 u2 u1 u0
          "punpcklbw %%mm1, %%mm1\n\t"         // mm1: u3 u3 u2 u2 u1 u1 u0 u0
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 u1 00 u1 00 u0 00 u0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "psllw     $3, %%mm1\n\t"            // u << 3
          "movd      (%3), %%mm0\n\t"          // mm0: 00 00 00 00 v3 v2 v1 v0
          "punpcklbw %%mm0, %%mm0\n\t"         // mm0: v3 v3 v2 v2 v1 v1 v0 v0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v1 00 v1 00 v0 00 v0
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // v << 3
          "movq      %%mm0, %%mm4\n\t"         // mm4: 00 v1 00 v1 00 v0 00 v0
          "pmulhw    proc_table+40, %%mm4\n\t" // v red
          "movq      %%mm4, %%mm5\n\t"
          "paddw     %%mm3, %%mm4\n\t"         // mm4: XX r03 XX r02 XX r01 XX r00
          "paddw     %%mm2, %%mm5\n\t"         // mm5: XX r13 XX r12 XX r11 XX r10
          "packuswb  %%mm5, %%mm4\n\t"         // mm4: r13 r12 r11 r10 r03 r02 r01 r00
          "movq      %%mm1, %%mm5\n\t"         // mm5: 00 u1 00 u1 00 u0 00 u0
          "pmulhw    proc_table+64, %%mm5\n\t" // u blue
          "movq      %%mm5, %%mm6\n\t"
          "paddw     %%mm3, %%mm5\n\t"         // mm5: XX b03 XX b02 XX b01 XX b00
          "paddw     %%mm2, %%mm6\n\t"         // mm6: XX b13 XX b12 XX b11 XX b00
          "packuswb  %%mm6, %%mm5\n\t"         // mm5: b13 b12 b11 b10 b03 b02 b01 b00
          "pmulhw    proc_table+48, %%mm0\n\t" // v green
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "paddw     %%mm1, %%mm0\n\t"         // u+v green
          "paddw     %%mm0, %%mm3\n\t"         // mm3: XX g03 XX g02 XX g01 XX g00
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g13 XX g12 XX g11 XX g10
          "packuswb  %%mm2, %%mm3\n\t"         // mm3: g13 g12 g11 g10 g03 g02 g01 g00
          "movq      %%mm5, %%mm0\n\t"         // mm0: b13 b12 b11 b10 b03 b02 b01 b00
          "punpcklbw %%mm3, %%mm0\n\t"         // mm0: g03 b03 g02 b02 g01 b01 g00 b00
          "movq      %%mm0, %%mm2\n\t"         // mm2: g03 b03 g02 b02 g01 b01 g00 b00
          "movq      %%mm5, %%mm1\n\t"         // mm1: b13 b12 b11 b10 b03 b02 b01 b00
          "punpcklbw %%mm4, %%mm1\n\t"         // mm1: r03 b03 r02 b02 r01 b01 r00 b00
          "psrld $8, %%mm1\n\t"                // mm1: 00 r03 b03 r02 00 r01 b01 r00
          "punpcklwd %%mm1, %%mm0\n\t"         // mm0: 00 r01 g01 b01 b01 r00 g00 b00
          "movq      %%mm0, %%mm6\n\t"         // mm6: 00 r01 g01 b01 b01 r00 g00 b00
          "psrlq     $40, %%mm6\n\t"           // mm6: 00 00 00 00 00 00 r01 g01
          "punpckhwd %%mm1, %%mm2\n\t"         // mm2: 00 r03 g03 b03 b03 r02 g02 b02
          "punpcklwd %%mm2, %%mm6\n\t"         // mm6: b03 r02 0 0 g02 b02 r01 g01
          "punpckldq %%mm6, %%mm0\n\t"         // mm0: g02 b02 r01 g01 b01 r00 g00 b00
          "movq      %%mm0, (%0)\n\t"
          "psrld     $8, %%mm2\n\t"            // mm1: 00 00 r03 g03 00 b03 r02 g02
          "psrld     $16, %%mm6\n\t"           // mm6: 00 00 b03 r02 00 00 g02 b02
          "punpckhwd %%mm2, %%mm6\n\t"         // mm6: 00 00 00 00 r03 g03 b03 r02
          "movd      %%mm6, 8(%0)\n\t"
          "movq      %%mm5, %%mm0\n\t"         // mm0: b13 b12 b11 b10 b03 b02 b01 b00
          "punpckhbw %%mm3, %%mm0\n\t"         // mm0: g13 b13 g12 b12 g11 b11 g10 b10
          "movq      %%mm0, %%mm2\n\t"         // mm2: g13 b13 g12 b12 g11 b11 g10 b10
          "punpckhbw %%mm4, %%mm5\n\t"         // mm5: r13 b13 r12 b12 r11 b11 r10 b10
          "psrld     $8, %%mm5\n\t"            // mm5: 00 r13 b13 r12 00 r11 b11 r10
          "punpcklwd %%mm5, %%mm0\n\t"         // mm0: 00 r11 g11 b11 b11 r10 g10 b10
          "movq      %%mm0, %%mm6\n\t"         // mm6: 00 r11 g11 b11 b11 r10 g10 b10
          "psrlq     $40, %%mm6\n\t"           // mm6: 00 00 00 00 00 00 r11 b11
          "punpckhwd %%mm5, %%mm2\n\t"         // mm2: 00 r13 g13 b13 b13 r12 g12 b12
          "punpcklwd %%mm2, %%mm6\n\t"         // mm6: b13 r12 0 0 g12 b12 r11 g11
          "punpckldq %%mm6, %%mm0\n\t"         // mm0: g12 b12 r11 g11 b11 r10 g10 b10
          "movq      %%mm0, (%0,%5)\n\t"
          "psrld     $8, %%mm2\n\t"            // mm2: 00 00 r13 g13 00 b13 r12 g12
          "psrld     $16, %%mm6\n\t"           // mm6: 00 00 b13 r12 00 00 g12 b12
          "punpckhwd %%mm2, %%mm6\n\t"         // mm6: 00 00 00 00 r13 g13 b13 r12
          "movd      %%mm6, 8(%0,%5)\n\t"
          "addl      $12, %0\n\t"
          "addl      $4, %1\n\t"
          "addl      $2, %2\n\t"
          "addl      $2, %3\n\t"
          "decl      %6\n\t"
          "jnz       1b\n\t"
          "movl      %4, %6\n\t"
          "shrl      $2, %6\n\t"
          "leal      (%0,%5), %0\n\t"
          "addl      %4, %1\n\t"
          "decl      %7\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&r" (Sy), "=&r" (Su), "=&r" (Sv)
          : "q" (frame->width), "q" (frame->width*3), "m" (l), "m" (n),
            "0" (D), "1" (Sy), "2" (Su), "3" (Sv)
          : "memory");
}

static
DFB_PFUNCTION( yv12, rgb32 )
{
     uint8_t *Sy = frame->vo_frame.base[0];
     uint8_t *Su = frame->vo_frame.base[1];
     uint8_t *Sv = frame->vo_frame.base[2];
     uint8_t *D  = frame->out_plane[0];
     int      n  = frame->height/2;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movd      (%1), %%mm3\n\t"          // mm3: 00 00 00 00 y03 y02 y01 y00
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 y03 00 y02 00 y01 00 y00
          "psubw     proc_table, %%mm3\n\t"    // y0X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm3\n\t"            // y0X << 3
          "pmulhw    proc_table+24, %%mm3\n\t" // y0X * proc_table.mmx.lm_cfc
          "movd      (%1,%4), %%mm2\n\t"       // mm2: 00 00 00 00 y13 y12 y11 y10
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 y13 00 y12 00 y11 00 y10
          "psubw     proc_table, %%mm2\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y1X * proc_table.mmx.uv_sub
          "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 u3 u2 u1 u0
          "punpcklbw %%mm1, %%mm1\n\t"         // mm1: u3 u3 u2 u2 u1 u1 u0 u0
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 u1 00 u1 00 u0 00 u0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "psllw     $3, %%mm1\n\t"            // u << 3
          "movd      (%3), %%mm0\n\t"          // mm0: 00 00 00 00 v3 v2 v1 v0
          "punpcklbw %%mm0, %%mm0\n\t"         // mm0: v3 v3 v2 v2 v1 v1 v0 v0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v1 00 v1 00 v0 00 v0
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // v << 3
          "movq      %%mm0, %%mm4\n\t"         // mm4: 00 v1 00 v1 00 v0 00 v0
          "pmulhw    proc_table+40, %%mm4\n\t" // v red
          "movq      %%mm4, %%mm5\n\t"
          "paddw     %%mm3, %%mm4\n\t"         // mm4: XX r03 XX r02 XX r01 XX r00
          "paddw     %%mm2, %%mm5\n\t"         // mm5: XX r13 XX r12 XX r11 XX r10
          "packuswb  %%mm5, %%mm4\n\t"         // mm4: r13 r12 r11 r10 r03 r02 r01 r00
          "movq      %%mm1, %%mm5\n\t"         // mm5: 00 u1 00 u1 00 u0 00 u0
          "pmulhw    proc_table+64, %%mm5\n\t" // u blue
          "movq      %%mm5, %%mm6\n\t"
          "paddw     %%mm3, %%mm5\n\t"         // mm5: XX b03 XX b02 XX b01 XX b00
          "paddw     %%mm2, %%mm6\n\t"         // mm6: XX b13 XX b12 XX b11 XX b00
          "packuswb  %%mm6, %%mm5\n\t"         // mm5: b13 b12 b11 b10 b03 b02 b01 b00
          "pmulhw    proc_table+48, %%mm0\n\t" // v green
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "paddw     %%mm1, %%mm0\n\t"         // v+u green
          "paddw     %%mm0, %%mm3\n\t"         // mm3: XX g03 XX g02 XX g01 XX g00
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g13 XX g12 XX g11 XX g10
          "packuswb  %%mm2, %%mm3\n\t"         // mm3: g13 g12 g11 g10 g03 g02 g01 g00
          "movq      %%mm4, %%mm0\n\t"         // mm0: r13 r12 r11 r10 r03 r02 r01 r00
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 r03 00 r02 00 r01 00 r00
          "movq      %%mm5, %%mm1\n\t"         // mm1: b13 b12 b11 b10 b03 b02 b01 b00
          "punpcklbw %%mm3, %%mm1\n\t"         // mm1: g03 b03 g02 b02 g01 b01 g00 b00
          "movq      %%mm1, %%mm2\n\t"         // mm2: g03 b03 g02 b02 g01 b01 g00 b00
          "punpcklwd %%mm0, %%mm2\n\t"         // mm2: 00 r01 g01 b01 00 r00 g00 b00
          "movq      %%mm2, (%0)\n\t"
          "punpckhwd %%mm0, %%mm1\n\t"         // mm1: 00 r03 g03 b03 00 r02 g02 b02
          "movq      %%mm1, 8(%0)\n\t"
          "punpckhbw %%mm7, %%mm4\n\t"         // mm4: 00 r13 00 r12 00 r11 00 r10
          "punpckhbw %%mm3, %%mm5\n\t"         // mm5: g13 b13 g12 b12 g11 b11 g10 b10
          "movq      %%mm5, %%mm0\n\t"         // mm0: g13 b13 g12 b12 g11 b11 g10 b10
          "punpcklwd %%mm4, %%mm0\n\t"         // mm0: 00 r11 g11 b11 00 r10 g10 b10
          "movq      %%mm0, (%0,%4,4)\n\t"
          "punpckhwd %%mm4, %%mm5\n\t"         // mm5: 00 r13 g13 b13 00 r12 g12 b12
          "movq      %%mm5, 8(%0,%4,4)\n\t"
          "addl      $16, %0\n\t"
          "addl      $4,  %1\n\t"
          "addl      $2,  %2\n\t"
          "addl      $2,  %3\n\t"
          "decl      %5\n\t"
          "jnz       1b\n\t"
          "movl      %4, %5\n\t"
          "shll      $2, %5\n\t"
          "addl      %5, %0\n\t"
          "addl      %4, %1\n\t"
          "shrl      $4, %5\n\t"
          "decl      %6\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&r" (Sy), "=&r" (Su), "=&r" (Sv)
          : "q" (frame->width), "c" (frame->width/4), "m" (n),
            "0" (D), "1" (Sy), "2" (Su), "3" (Sv)
          : "memory");
}

static
DFB_PFUNCTION( yv12, argb )
{
     uint8_t *Sy = frame->vo_frame.base[0];
     uint8_t *Su = frame->vo_frame.base[1];
     uint8_t *Sv = frame->vo_frame.base[2];
     uint8_t *D  = frame->out_plane[0];
     int      n  = frame->height/2;

     __asm__ __volatile__(
          "pxor      %%mm7, %%mm7\n\t"         // mm7: 00 00 00 00 00 00 00 00
          ".align 16\n"
          "1:\n\t"
          "movd      (%1), %%mm3\n\t"          // mm3: 00 00 00 00 y03 y02 y01 y00
          "punpcklbw %%mm7, %%mm3\n\t"         // mm3: 00 y03 00 y02 00 y01 00 y00
          "psubw     proc_table, %%mm3\n\t"    // y0X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm3\n\t"            // y0X << 3
          "pmulhw    proc_table+24, %%mm3\n\t" // y0X * proc_table.mmx.lm_cfc
          "movd      (%1,%4), %%mm2\n\t"       // mm2: 00 00 00 00 y13 y12 y11 y10
          "punpcklbw %%mm7, %%mm2\n\t"         // mm2: 00 y13 00 y12 00 y11 00 y10
          "psubw     proc_table, %%mm2\n\t"    // y1X - proc_table.mmx.lm_sub
          "psllw     $3, %%mm2\n\t"            // y1X << 3
          "pmulhw    proc_table+24, %%mm2\n\t" // y1X * proc_table.mmx.uv_sub
          "movd      (%2), %%mm1\n\t"          // mm1: 00 00 00 00 u3 u2 u1 u0
          "punpcklbw %%mm1, %%mm1\n\t"         // mm1: u3 u3 u2 u2 u1 u1 u0 u0
          "punpcklbw %%mm7, %%mm1\n\t"         // mm1: 00 u1 00 u1 00 u0 00 u0
          "psubw     proc_table+16, %%mm1\n\t" // u - proc_table.mmx.uv_sub
          "psllw     $3, %%mm1\n\t"            // u << 3
          "movd      (%3), %%mm0\n\t"          // mm0: 00 00 00 00 v3 v2 v1 v0
          "punpcklbw %%mm0, %%mm0\n\t"         // mm0: v3 v3 v2 v2 v1 v1 v0 v0
          "punpcklbw %%mm7, %%mm0\n\t"         // mm0: 00 v1 00 v1 00 v0 00 v0
          "psubw     proc_table+16, %%mm0\n\t" // v - proc_table.mmx.uv_sub
          "psllw     $3, %%mm0\n\t"            // v << 3
          "movq      %%mm0, %%mm4\n\t"         // mm4: 00 v1 00 v1 00 v0 00 v0
          "pmulhw    proc_table+40, %%mm4\n\t" // v red
          "movq      %%mm4, %%mm5\n\t"
          "paddw     %%mm3, %%mm4\n\t"         // mm4: XX r03 XX r02 XX r01 XX r00
          "paddw     %%mm2, %%mm5\n\t"         // mm5: XX r13 XX r12 XX r11 XX r10
          "packuswb  %%mm5, %%mm4\n\t"         // mm4: r13 r12 r11 r10 r03 r02 r01 r00
          "movq      %%mm1, %%mm5\n\t"         // mm5: 00 u1 00 u1 00 u0 00 u0
          "pmulhw    proc_table+64, %%mm5\n\t" // u blue
          "movq      %%mm5, %%mm6\n\t"
          "paddw     %%mm3, %%mm5\n\t"         // mm5: XX b03 XX b02 XX b01 XX b00
          "paddw     %%mm2, %%mm6\n\t"         // mm6: XX b13 XX b12 XX b11 XX b00
          "packuswb  %%mm6, %%mm5\n\t"         // mm5: b13 b12 b11 b10 b03 b02 b01 b00
          "pmulhw    proc_table+48, %%mm0\n\t" // v green
          "pmulhw    proc_table+56, %%mm1\n\t" // u green
          "paddw     %%mm1, %%mm0\n\t"         // v+u green
          "paddw     %%mm0, %%mm3\n\t"         // mm3: XX g03 XX g02 XX g01 XX g00
          "paddw     %%mm0, %%mm2\n\t"         // mm2: XX g13 XX g12 XX g11 XX g10
          "packuswb  %%mm2, %%mm3\n\t"         // mm3: g13 g12 g11 g10 g03 g02 g01 g00
          "movq      %%mm4, %%mm0\n\t"         // mm0: r13 r12 r11 r10 r03 r02 r01 r00
          "punpcklbw a8mask, %%mm0\n\t"        // mm0: ff r03 ff r02 ff r01 ff r00
          "movq      %%mm5, %%mm1\n\t"         // mm1: b13 b12 b11 b10 b03 b02 b01 b00
          "punpcklbw %%mm3, %%mm1\n\t"         // mm1: g03 b03 g02 b02 g01 b01 g00 b00
          "movq      %%mm1, %%mm2\n\t"         // mm2: g03 b03 g02 b02 g01 b01 g00 b00
          "punpcklwd %%mm0, %%mm2\n\t"         // mm2: ff r01 g01 b01 ff r00 g00 b00
          "movq      %%mm2, (%0)\n\t"
          "punpckhwd %%mm0, %%mm1\n\t"         // mm1: ff r03 g03 b03 ff r02 g02 b02
          "movq      %%mm1, 8(%0)\n\t"
          "punpckhbw a8mask, %%mm4\n\t"        // mm4: ff r13 ff r12 ff r11 ff r10
          "punpckhbw %%mm3, %%mm5\n\t"         // mm5: g13 b13 g12 b12 g11 b11 g10 b10
          "movq      %%mm5, %%mm0\n\t"         // mm0: g13 b13 g12 b12 g11 b11 g10 b10
          "punpcklwd %%mm4, %%mm0\n\t"         // mm0: ff r11 g11 b11 ff r10 g10 b10
          "movq      %%mm0, (%0,%4,4)\n\t"
          "punpckhwd %%mm4, %%mm5\n\t"         // mm5: ff r13 g13 b13 ff r12 g12 b12
          "movq      %%mm5, 8(%0,%4,4)\n\t"
          "addl      $16, %0\n\t"
          "addl      $4,  %1\n\t"
          "addl      $2,  %2\n\t"
          "addl      $2,  %3\n\t"
          "decl      %5\n\t"
          "jnz       1b\n\t"
          "movl      %4, %5\n\t"
          "shll      $2, %5\n\t"
          "addl      %5, %0\n\t"
          "addl      %4, %1\n\t"
          "shrl      $4, %5\n\t"
          "decl      %6\n\t"
          "jnz       1b\n\t"
          "emms"
          : "=&D" (D), "=&r" (Sy), "=&r" (Su), "=&r" (Sv)
          : "q" (frame->width), "c" (frame->width/4), "m" (n),
            "0" (D), "1" (Sy), "2" (Su), "3" (Sv)
          : "memory");
}

/******************************** End of YV12 callbacks *********************************/

#undef PACCEL

