#ifndef DF_XINE_KEYMAP_H
#define DF_XINE_KEYMAP_H


static const DFXKeyControl kmap[] =
{
     {
          .key    = DIKS_ESCAPE,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_QUIT,
          .param  = 0,
          .help   = "quit",
          .stdctl = "Quit"
     },
     {
          .key    = DIKS_EXIT,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_QUIT,
          .param  = 0,
          .help   = "quit",
          .stdctl = "Quit"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_ENTER,
          .event  = 0,
          .actid  = DAI_TOGGLE_PLAY,
          .param  = 0,
          .help   = "toggle play/stop",
          .stdctl = "Stop"
     },
     {
          .key    = DIKS_PLAY,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_TOGGLE_PLAY,
          .param  = 0,
          .help   = "toggle play/stop",
          .stdctl = "Stop"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_SMALL_P,
          .event  = 0,
          .actid  = DAI_PLAY,
          .param  = DAP_MINUS,
          .help   = "play prevoius mrl in playlist",
          .stdctl = "PriorMrl"
     },
     {
          .key    = DIKS_PREVIOUS,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_PLAY,
          .param  = DAP_MINUS,
          .help   = "play prevoius mrl in playlist",
          .stdctl = "PriorMrl"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_SMALL_N,
          .event  = 0,
          .actid  = DAI_PLAY,
          .param  = DAP_PLUS,
          .help   = "play next mrl in playlist",
          .stdctl = "NextMrl"
     },
     {
          .key    = DIKS_NEXT,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_PLAY,
          .param  = DAP_PLUS,
          .help   = "play next mrl in playlist",
          .stdctl = "NextMrl"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_SPACE,
          .event  = 0,
          .actid  = DAI_TOGGLE_PAUSE,
          .param  = 0,
          .help   = "toggle pause mode",
          .stdctl = "Pause"
     },
     {
          .key    = DIKS_PLAYPAUSE,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_TOGGLE_PAUSE,
          .param  = 0,
          .help   = "toggle pause mode",
          .stdctl = "Pause"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_CURSOR_RIGHT,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_PLUS,
          .help   = "jump forward (+15 seconds)",
          .stdctl = "SeekRelative+15"
     },
     {
          .key    = DIKS_FORWARD,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_PLUS,
          .help   = "jump forward (+15 seconds)",
          .stdctl = "SeekRelative+15"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_CURSOR_LEFT,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_MINUS,
          .help   = "jump backward (-15 seconds)",
          .stdctl = "SeekRelative-15"
     },
     {
          .key    = DIKS_BACK,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_MINUS,
          .help   = "jump backward (-15 seconds)",
          .stdctl = "SeekRelative-15"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_0,
          .help   = "jump to  0% of video stream",
          .stdctl = "SetPosition0%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_1,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_1,
          .help   = "jump to 10% of video stream",
          .stdctl = "SetPosition10%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_2,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_2,
          .help   = "jump to 20% of video stream",
          .stdctl = "SetPosition20%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_3,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_3,
          .help   = "jump to 30% of video stream",
          .stdctl = "SetPosition30%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_4,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_4,
          .help   = "jump to 40% of video stream",
          .stdctl = "SetPosition40%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_5,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_5,
          .help   = "jump to 50% of video stream",
          .stdctl = "SetPosition50%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_6,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_6,
          .help   = "jump to 60% of video stream",
          .stdctl = "SetPosition60%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_7,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_7,
          .help   = "jump to 70% of video stream",
          .stdctl = "SetPosition70%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_8,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_8,
          .help   = "jump to 80% of video stream",
          .stdctl = "SetPosition80%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_9,
          .event  = 0,
          .actid  = DAI_SEEK,
          .param  = DAP_SEEK_9,
          .help   = "jump to 90% of video stream",
          .stdctl = "SetPosition90%"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_CURSOR_UP,
          .event  = 0,
          .actid  = DAI_SPEED,
          .param  = DAP_PLUS,
          .help   = "increase playback speed",
          .stdctl = "SpeedFaster"
     },
     {
          .key    = DIKS_FAST,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_SPEED,
          .param  = DAP_PLUS,
          .help   = "increase playback speed",
          .stdctl = "SpeedFaster"
     },
     {
          .key    = DIKS_CONTROL,
          .subkey = DIKS_CURSOR_DOWN,
          .event  = 0,
          .actid  = DAI_SPEED,
          .param  = DAP_MINUS,
          .help   = "decrease playback speed",
          .stdctl = "SpeedSlower"
     },
     {
          .key    = DIKS_SLOW,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_SPEED,
          .param  = DAP_MINUS,
          .help   = "decrease playback speed",
          .stdctl = "SpeedSlower"
     },
     {
          .key    = DIKS_SMALL_V,
          .subkey = DIKS_CURSOR_RIGHT,
          .event  = 0,
          .actid  = DAI_VOLUME,
          .param  = DAP_PLUS,
          .help   = "increase volume",
          .stdctl = "Volume+"
     },
     {
          .key    = DIKS_VOLUME_UP,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_VOLUME,
          .param  = DAP_PLUS,
          .help   = "increase volume",
          .stdctl = "Volume+"
     },
     {
          .key    = DIKS_SMALL_V,
          .subkey = DIKS_CURSOR_LEFT,
          .event  = 0,
          .actid  = DAI_VOLUME,
          .param  = DAP_MINUS,
          .help   = "decrease volume",
          .stdctl = "Volume-"
     },
     {
          .key    = DIKS_VOLUME_DOWN,
          .subkey = 0,
          .event  = 0,
          .actid  = DAI_VOLUME,
          .param  = DAP_MINUS,
          .help   = "decrease volume",
          .stdctl = "Volume-"
     },
     {
          .key    = DIKS_SMALL_B,
          .subkey = DIKS_CURSOR_RIGHT,
          .event  = 0,
          .actid  = DAI_BRIGHTNESS,
          .param  = DAP_PLUS,
          .help   = "increase brightness",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_B,
          .subkey = DIKS_CURSOR_LEFT,
          .event  = 0,
          .actid  = DAI_BRIGHTNESS,
          .param  = DAP_MINUS,
          .help   = "decrease brightness",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_B,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_BRIGHTNESS,
          .param  = DAP_RESET,
          .help   = "reset brightness",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_C,
          .subkey = DIKS_CURSOR_RIGHT,
          .event  = 0,
          .actid  = DAI_CONTRAST,
          .param  = DAP_PLUS,
          .help   = "increase contrast",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_C,
          .subkey = DIKS_CURSOR_LEFT,
          .event  = 0,
          .actid  = DAI_CONTRAST,
          .param  = DAP_MINUS,
          .help   = "decrease contrast",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_C,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_CONTRAST,
          .param  = DAP_RESET,
          .help   = "reset contrast",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_S,
          .subkey = DIKS_CURSOR_RIGHT,
          .event  = 0,
          .actid  = DAI_SATURATION,
          .param  = DAP_PLUS,
          .help   = "increase saturation",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_S,
          .subkey = DIKS_CURSOR_LEFT,
          .event  = 0,
          .actid  = DAI_SATURATION,
          .param  = DAP_MINUS,
          .help   = "decrease saturation",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_S,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_SATURATION,
          .param  = DAP_RESET,
          .help   = "reset saturation",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_H,
          .subkey = DIKS_CURSOR_RIGHT,
          .event  = 0,
          .actid  = DAI_HUE,
          .param  = DAP_PLUS,
          .help   = "increase hue",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_H,
          .subkey = DIKS_CURSOR_LEFT,
          .event  = 0,
          .actid  = DAI_HUE,
          .param  = DAP_MINUS,
          .help   = "decrease hue",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_H,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_HUE,
          .param  = DAP_RESET,
          .help   = "reset hue",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_R,
          .subkey = DIKS_1,
          .event  = 0,
          .actid  = DAI_RATIO,
          .param  = DAP_RATIO_SQUARE,
          .help   = "set 'Square' aspect ratio",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_R,
          .subkey = DIKS_2,
          .event  = 0,
          .actid  = DAI_RATIO,
          .param  = DAP_RATIO_43,
          .help   = "set '4:3' aspect ratio",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_R,
          .subkey = DIKS_3,
          .event  = 0,
          .actid  = DAI_RATIO,
          .param  = DAP_RATIO_169,
          .help   = "set 'Anamorphic' aspect ratio",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_R,
          .subkey = DIKS_4,
          .event  = 0,
          .actid  = DAI_RATIO,
          .param  = DAP_RATIO_DVB,
          .help   = "set 'DVB' aspect ratio",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_R,
          .subkey = DIKS_5,
          .event  = 0,
          .actid  = DAI_RATIO,
          .param  = DAP_RATIO_SCREEN,
          .help   = "set 'Screen' aspect ratio",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_R,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_RATIO,
          .param  = DAP_RESET,
          .help   = "reset default aspect ratio",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_Z,
          .subkey = DIKS_CURSOR_UP,
          .event  = 0,
          .actid  = DAI_ZOOM,
          .param  = DAP_PLUS,
          .help   = "increase zoom factor",
     },
     {
          .key    = DIKS_SMALL_Z,
          .subkey = DIKS_CURSOR_DOWN,
          .event  = 0,
          .actid  = DAI_ZOOM,
          .param  = DAP_MINUS,
          .help   = "decrease zoom factor",
     },
     {
          .key    = DIKS_SMALL_Z,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_ZOOM,
          .param  = DAP_RESET,
          .help   = "reset zoom factor",
     },
     {
          .key    = DIKS_SMALL_A,
          .subkey = DIKS_CURSOR_LEFT,
          .event  = 0,
          .actid  = DAI_AUDIO_CHANNEL,
          .param  = DAP_PLUS,
          .help   = "select next audio channel",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_A,
          .subkey = DIKS_CURSOR_RIGHT,
          .event  = 0,
          .actid  = DAI_AUDIO_CHANNEL,
          .param  = DAP_MINUS,
          .help   = "select previous audio channel",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_A,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_AUDIO_CHANNEL,
          .param  = DAP_RESET,
          .help   = "reset default audio channel",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_L,
          .subkey = DIKS_CURSOR_RIGHT,
          .event  = 0,
          .actid  = DAI_SPU_CHANNEL,
          .param  = DAP_PLUS,
          .help   = "select next subtitles channel",
          .stdctl = "SpuNext"
     },
     {
          .key    = DIKS_SMALL_L,
          .subkey = DIKS_CURSOR_LEFT,
          .event  = 0,
          .actid  = DAI_SPU_CHANNEL,
          .param  = DAP_MINUS,
          .help   = "select previous subtitles channel",
          .stdctl = "SpuPrior"
     },
     {
          .key    = DIKS_SMALL_L,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_SPU_CHANNEL,
          .param  = DAP_RESET,
          .help   = "reset default subtitles channel",
          .stdctl = "SpuDefault"
     },
     {
          .key    = DIKS_SMALL_D,
          .subkey = DIKS_1,
          .event  = 0,
          .actid  = DAI_DEINTERLACE,
          .param  = DAP_FIELD_TOP,
          .help   = "force deinterlacing (top field first)",
          .stdctl = NULL
     },
     { 
          .key    = DIKS_SMALL_D,
          .subkey = DIKS_2,
          .event  = 0,
          .actid  = DAI_DEINTERLACE,
          .param  = DAP_FIELD_BOTTOM,
          .help   = "force deinterlacing (bottom field first)",
          .stdctl = NULL
     },
     {
          .key    = DIKS_SMALL_D,
          .subkey = DIKS_0,
          .event  = 0,
          .actid  = DAI_DEINTERLACE,
          .param  = DAP_FIELD_AUTO,
          .help   = "reset automatic deinterlacing",
          .stdctl = NULL
     },
     {
          .key    = DIKS_DELETE,
          .subkey = 0,
          .actid  = DAI_OSD_HIDE,
          .param  = 0,
          .help   = "hide OSD",
          .stdctl = NULL
     },
/* events */
     {
          .key    = DIKS_F1,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_MENU1,
          .help   = "jump to menu",
          .stdctl = "Menu"
     },
     {
          .key    = DIKS_F2,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_MENU2,
          .help   = "jump to Title menu",
          .stdctl = "TitleMenu"
     },
     {
          .key    = DIKS_F3,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_MENU3,
          .help   = "jump to Root menu",
          .stdctl = "RootMenu"
     },
     {
          .key    = DIKS_F4,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_MENU4,
          .help   = "jump to Subtitles menu",
          .stdctl = "SubpictureMenu"
     },
     {
          .key    = DIKS_F5,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_MENU5,
          .help   = "jump to Audio menu",
          .stdctl = "AudioMenu"
     },
     {
          .key    = DIKS_F6,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_MENU6,
          .help   = "jump to Angle menu",
          .stdctl = "AngleMenu"
     },
     {
          .key    = DIKS_F7,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_MENU7,
          .help   = "jump to Part menu",
          .stdctl = "PartMenu"
     },
     {
          .key    = DIKS_CURSOR_UP,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_UP,
          .help   = "move up",
          .stdctl = "EventUp"
     },
     {
          .key    = DIKS_CURSOR_DOWN,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_DOWN,
          .help   = "move down",
          .stdctl = "EventDown"
     },
     {
          .key    = DIKS_CURSOR_LEFT,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_LEFT,
          .help   = "move left",
          .stdctl = "EventLeft"
     },
     {
          .key    = DIKS_CURSOR_RIGHT,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_RIGHT,
          .help   = "move right",
          .stdctl = "EventRight"
     },
     {
          .key    = DIKS_ENTER,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_SELECT,
          .help   = "select",
          .stdctl = "EventSelect"
     },
     {
          .key    = DIKS_PAGE_DOWN,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NEXT,
          .help   = "go to next chapter",
          .stdctl = "EventNext"
     },
     {
          .key    = DIKS_PAGE_UP,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_PREVIOUS,
          .help   = "go to previous chapter",
          .stdctl = "EventPrior"
     },
     {
          .key    = DIKS_END,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_ANGLE_NEXT,
          .help   = "select angle next",
          .stdctl = "EventAngleNext"
     },
     {
          .key    = DIKS_HOME,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_ANGLE_PREVIOUS,
          .help   = "select angle previous",
          .stdctl = "EventAnglePrior"
     },
     {
          .key    = DIKS_0,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_0,
          .help   = "enter number 0",
          .stdctl = "Number0"
     },
     {
          .key    = DIKS_1,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_1,
          .help   = "enter number 1",
          .stdctl = "Number1"
     },
     {
          .key    = DIKS_2,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_2,
          .help   = "enter number 2",
          .stdctl = "Number2"
     },
     {
          .key    = DIKS_3,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_3,
          .help   = "enter number 3",
          .stdctl = "Number3"
     },
     {
          .key    = DIKS_4,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_4,
          .help   = "enter number 4",
          .stdctl = "Number4"
     },
     {
          .key    = DIKS_5,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_5,
          .help   = "enter number 5",
          .stdctl = "Number5"
     },
     {
          .key    = DIKS_6,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_6,
          .help   = "enter number 6",
          .stdctl = "Number6"
     },
     {
          .key    = DIKS_7,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_7,
          .help   = "enter number 7",
          .stdctl = "Number7"
     },
     {
          .key    = DIKS_8,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_8,
          .help   = "enter number 8",
          .stdctl = "Number8"
     },
     {
          .key    = DIKS_9,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_9,
          .help   = "enter number 9",
          .stdctl = "Number9"
     },
     {
          .key    = DIKS_PLUS_SIGN,
          .subkey = 0,
          .event  = XINE_EVENT_INPUT_NUMBER_10_ADD,
          .help   = "add 10 to next entered number",
          .stdctl = "Number10add"
     }
};


#endif /* DF_XINE_KEYMAP_H */
